package a_program;

import c_kml.KmlSpline;
import c_scenario.MessageFrame;
import c_scenario.ScenarioActionStateChanger;
import c_scenario.ScenarioActionSystem;
import c_scenario.ScenarioEvent;
import c_scenario.ScenarioItem;
import c_scenario.ScenarioTriggerSpeed;
import c_scenario.ScenarioTriggerTrackPos;
import c_trackNode.TrackNode;
import c_trase.AltTextfileReader;
import c_trase.KmlSplineTrase;
import com.jme3.app.SimpleApplication;
import com.jme3.input.KeyInput;
import com.jme3.input.controls.ActionListener;
import com.jme3.input.controls.KeyTrigger;
import com.jme3.light.AmbientLight;
import com.jme3.light.DirectionalLight;
import com.jme3.math.ColorRGBA;
import com.jme3.math.Vector3f;
import com.jme3.niftygui.NiftyJmeDisplay;
import com.jme3.scene.CameraNode;
import com.jme3.scene.Geometry;
import com.jme3.scene.Node;
import com.jme3.scene.control.CameraControl.ControlDirection;
import com.jme3.system.AppSettings;
import com.jme3.system.JmeCanvasContext;
import com.jme3.util.SkyFactory;
import de.lessvoid.nifty.Nifty;
import e_section.Section;
import e_section.SectionInfo;
import e_track.SwitchPositioner;
import e_track.SwitchTrack;
import e_track.TrackElement;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.util.ArrayList;
import java.util.Timer;
import java.util.TimerTask;
import javax.swing.JFrame;
import javax.swing.JPanel;
import jme3tools.optimize.GeometryBatchFactory;
import e_catenary.KL;
import e_catenary.KLKomponent;
import n_no_tco.NoFS;
import n_no_tco.NoHS2;
import n_no_tco.NoHS3;
import e_tco.TrackConnectedObject;
import e_tco.UpdateObject;
import vehicle.SimTrainInfo;
import vehicle.SimSimpleVehicle;
import vehicle.Vehicle;
import vehicle_traction_brake_system.SkalHastPanel;
import xml.BaseObjectXML;
import xml.MyXmlCreatorScenario;
import xml.MyXmlCreatorTCO;
import xml.MyXmlCreatorTER;
import xml.MyXmlReader;
import a_tb_3d.StaticTerrainObjectData;
import a_tb_3d.TbFrame;
import a_tb_3d.TbPanel;
import c_scenario.InfoFrame;
import c_scenario.InfoFrame2;
import c_scenario.ScenarioActionAutoTrainCommand;
import c_scenario.ScenarioActionBaliseErrorBits;
import c_scenario.ScenarioActionFollowSimTrain;
import c_scenario.ScenarioBasedTCO;
import c_scenario.Txp;
import c_trackNode.TrackRunner;
import com.jme3.collision.CollisionResults;
import com.jme3.input.MouseInput;
import com.jme3.input.RawInputListener;
import com.jme3.input.event.JoyAxisEvent;
import com.jme3.input.event.JoyButtonEvent;
import com.jme3.input.event.KeyInputEvent;
import com.jme3.input.event.MouseButtonEvent;
import com.jme3.input.event.MouseMotionEvent;
import com.jme3.input.event.TouchEvent;
import com.jme3.light.SpotLight;
import com.jme3.math.FastMath;
import com.jme3.math.Ray;
import com.jme3.math.Vector2f;
import com.jme3.scene.Spatial;
import com.jme3.scene.control.LightControl;
import com.jme3.ui.Picture;
import de.lessvoid.nifty.controls.CheckBox;
import de.lessvoid.nifty.controls.Label;
import de.lessvoid.nifty.controls.ScrollPanel;
import de.lessvoid.nifty.elements.Element;
import de.lessvoid.nifty.elements.render.ImageRenderer;
import de.lessvoid.nifty.render.NiftyImage;
import de.lessvoid.nifty.render.batch.spi.BatchRenderBackend;
import de.lessvoid.nifty.render.batch.spi.BatchRenderBackend.Image;
import de.lessvoid.nifty.render.image.ImageMode;
import de.lessvoid.nifty.screen.Screen;
import de.lessvoid.nifty.tools.SizeValue;
import e_track.CurveTrack;
import e_track.Track;
import f_general.MyAudioNode;
import f_general.TekstfilLeser;
import f_general.TekstfilSkriver;
import g_manuellstyring.ManStyringFrame;
import java.io.File;
import java.util.GregorianCalendar;
import java.util.Random;
import javax.swing.ImageIcon;
import m_ertms_remote.RBC;
import m_ertms_tco.ErtmsHastProfil;
import vehicle.AutoVehicle1;
import vehicle.Kobbel;
import vehicle.TrainCreator;
import vehicle.TrainCreatorSimSimpleAtcErtmsTrain;
import xml.MyXmlCreatorTER_NEW;
import xml.MyXmlCreatorTRACK;
import xml.MyXmlSaverTCO;

// vr import
import com.jme3.app.VRAppState;
import com.jme3.app.VRConstants;
import com.jme3.app.VREnvironment;
import com.jme3.app.state.AppState;
import com.jme3.asset.AssetManager;
import com.jme3.bullet.BulletAppState;
import com.jme3.bullet.collision.shapes.CapsuleCollisionShape;
import com.jme3.bullet.control.BetterCharacterControl;
import com.jme3.bullet.control.RigidBodyControl;
import com.jme3.input.vr.VRInputType;
import com.jme3.input.vr.openvr.OpenVR;
import com.jme3.input.vr.openvr.OpenVRInput;
import com.jme3.material.Material;
import com.jme3.math.Matrix3f;
import com.jme3.math.Quaternion;
import com.jme3.math.Transform;
import com.jme3.post.FilterPostProcessor;
import com.jme3.post.filters.BloomFilter;
import com.jme3.post.filters.TranslucentBucketFilter;
import com.jme3.renderer.Camera;
import com.jme3.scene.shape.Box;
import com.jme3.scene.shape.Line;
import com.jme3.system.JmeContext;
import com.jme3.system.JmeContext.Type;
import com.jme3.system.jopenvr.VRControllerAxis_t;
import com.jme3.system.jopenvr.VRControllerState_t;
import com.jme3.util.VRGUIPositioningMode;
import com.sun.org.apache.bcel.internal.generic.NOP;
import e_tco.GeometryAction;
import javax.swing.JOptionPane;
import m_ertms_tco.TyDverg;
import n_no_tco.Balise;
import vehicle.AirCoupling;
import vehicle.Coupling;
import vehicle.Guardrail;
import vehicle.Stigtrinn;
import z_test_real_atc.ATCMetoder;

//  For networking
import com.jme3.network.Client;
import com.jme3.network.Network;
import com.jme3.network.Server;
import java.io.IOException;
import java.util.logging.Level;
import java.util.logging.Logger;
import Networking.messaging.TrainMoveMessage;
import Networking.messaging.VrPersonMoveMessage;
import Networking.messaging;
import Networking.messaging.ClientMessageListener;
import Networking.messaging.ServerMessageListener;


public class Program extends SimpleApplication {

    public static Node rootNode;
    public static AssetManager assetManager;
    public static Camera cam;
    public static BulletAppState bulletAppState;
    public static AppSettings settings;
    public static VRAppState vrAppState = null;
    
    private Node simTrainNode;
    private TrackNode startTrackNode;
    public static Vehicle simVeh;
    private static ArrayList<Vehicle> autoVehicleList = new ArrayList<Vehicle>();
    private static ArrayList<Vehicle> fullVehicleList = new ArrayList<Vehicle>();
    private static ArrayList<Section> sectionList = new ArrayList<Section>();
    private ArrayList<SwitchPositioner> switchPositionerList = new ArrayList<SwitchPositioner>();
    private ArrayList<SwitchTrack> switchTrackList = new ArrayList<SwitchTrack>();
    private ArrayList<UpdateObject> updateObjectList = new ArrayList<UpdateObject>();
    private ArrayList<Balise> noAtcBaliseList = new ArrayList<Balise>();
    private ArrayList<Txp> workerList = new ArrayList<Txp>();
    private static ArrayList<MyAudioNode> vehicleAudioList = new ArrayList<MyAudioNode>();

    // initial flycamspeed
    private float flyCamSpeed = 10;

    // info from scenario
    private SimTrainInfo simTrainInfo;
    public static boolean startCondScenario = false;

    // scenario
    private static ArrayList<ScenarioEvent> scenarioEventList = new ArrayList<ScenarioEvent>();

    public static MessageFrame messageFrame;

    public static InfoFrame infoFrame;
    public static InfoFrame2 infoFrame2;

    public static int scenarioTriggerInt0 = 0;
    public static int scenarioTriggerInt1 = 0;

    // RBC
    private RBC rbc = new RBC();

    // Spoling  
    private boolean spolingOn = false;

    // Scenario build mode
    public static final boolean SCENARIO_BUILD_MODE = false;
    public static boolean mouseSpolOpened = false;

    // TrackBuilder stuff
    public static boolean TRACK_BUILD_MODE = false;//true;
    private TbFrame tbFrame;
    private TerrainOperations terrainOperations;
    private TcoOperations tcoOperations;
    private static String trackBuildSectionName = "";
    //

    // newTerrain
    public static boolean newTerrain = false;

    // manuell styring
    ManStyringFrame msf;

    // startframe
    public static StartFrame startFrame;

    // simulert tid
    public static GregorianCalendar simTid = new GregorianCalendar(2010, 1, 1, 12, 0, 0);

    // static main vehicle
    public static SimSimpleVehicle vrVehicle;

    // update system
    private UpdateTask250 updateTask250;

    // vr app state
    public static boolean vrOn = false;

    //    VR variables
    public static VrPerson vrPerson;
    public static float forwardMove;
    public static float rightMove;
    public static float upKey;
    public static float leftKey;
    public static float downKey;
    public static float rightKey;

    // ytre komponenter
    public static boolean loadDetailedComponents = false;

    // busy check
    public static int busyCount = 0;

    // vis dilaogbox med poengsum til slutt
    public static boolean showPointsDialogAtEnd = false;

    // real atc
    public static ATCMetoder atcMetoder;

    // altternative slides
    private static boolean hasAlternativeSlides = false;

    // atc balise codes in program change
    public static Balise activeBalise = null;
    public static int editBaliseCodeNum = 0;
    public static int editBaliseCodeIndex = 0;

    // new lighting
    public static ArrayList<String> modelFilesNL = new ArrayList<>();
    private Vector3f scenarioSunDirection; // x:tilt, y:rotation, z:no function
    private ColorRGBA scenarioAmbient;
    
    //  Networking
    private static Server myServer;
    private static Client myClient;
    public static boolean isServer = false;
    public static boolean isClient = false;
    
    public static TrainMoveMessage trainMoveQueue;
    public static VrPersonMoveMessage vrPersonMoveQueue;
    
    private float lastSpeed;
    private float lastOdom;
    private int lastDir;
    
    private Vector3f lastPos = new Vector3f();
    private Vector3f lastRot = new Vector3f();
    
    private float timeSinceUpdate = 0;

    // Contructor
    public Program() {

    }

    public Program(AppState... initialStates) {
        super(initialStates);

        vrAppState = getStateManager().getState(VRAppState.class);
    }

    // main
    public static void main(String[] args) {

        String s = TekstfilLeser.lesFil("config.txt");
        String custMenu = null;
        if (s.contains("customizedmenu=nsbk")) {
            System.out.println("Customized menu: NSBK");
            custMenu = "nsbk";
        } else {
            if (s.contains("customizedmenu=ertmsnasjonal")) {
                System.out.println("Customized menu: ERTMSnasjonal");
                custMenu = "ertmsnasjonal";
            }
        }

        StartFrame.custMenu = custMenu;
        startFrame = new StartFrame();
    }

    public static void main1SWING(String[] args) // add vr to this if this is beeing kept
    {
        if (args != null && args.length == 2) {
            if (args[0].equals("build")) {
                TRACK_BUILD_MODE = true;
                trackBuildSectionName = args[1];
                StartParameters.scenarioName = "sc_z_atc_build";
            }
        }

        // all stored fram locations
        StoreConfig.readAllFrameLocations();
        StoreConfig.readAllGeneralConfig();

        // cgi
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                int xsize = StartParameters.worldPanelSizeX;//1600;//1920; //800
                int ysize = StartParameters.worldPanelSizeY;//900;//1199; //600

                Program canvasApplication = new Program();

                canvasApplication.setPauseOnLostFocus(false);
                canvasApplication.setSettings(settings);
                canvasApplication.setShowSettings(false);
                canvasApplication.setDisplayStatView(false);
                canvasApplication.setDisplayFps(false);
                canvasApplication.createCanvas(); // create canvas!

                JmeCanvasContext ctx = (JmeCanvasContext) canvasApplication.getContext();
                ctx.setSystemListener(canvasApplication);
                Dimension dim = new Dimension(xsize, ysize);
                ctx.getCanvas().setPreferredSize(dim);

                JFrame frame = new JFrame();
                frame.setIconImage(new ImageIcon("assets/models/caption_image.png").getImage());
                frame.setUndecorated(StartParameters.worldPanelUnDecorated);
                frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

                FlowLayout fl = new FlowLayout();
                fl.setHgap(0);
                fl.setVgap(0);

                JPanel panel = new JPanel(fl);
                panel.setBackground(Color.black);

                panel.add(ctx.getCanvas());
                frame.add(panel);

                frame.pack();
                frame.setVisible(true);

                canvasApplication.startCanvas();
            }
        });
    }

    public static void main1(String[] args) // no swing
    {
        if (args != null && args.length == 2) {
            if (args[0].equals("build")) {
                TRACK_BUILD_MODE = true;
                trackBuildSectionName = args[1];
                StartParameters.scenarioName = "sc_z_atc_build";
            }
        }

        // all stored fram locations
        StoreConfig.readAllFrameLocations();
        StoreConfig.readAllGeneralConfig();

        openRealAtcUsbComm();

        Thread t = new Thread(new Runnable() {
            @Override
            public void run() {
                //Program program = new Program();
                int xsize = StartParameters.worldPanelSizeX;//1600;//1920; //800
                int ysize = StartParameters.worldPanelSizeY + 1;//900;//1199; //600

                System.out.println("x: " + xsize + " y: " + ysize);
                loadDetailedComponents = StartParameters.showComponents;
                isServer = StartParameters.server;
                isClient = StartParameters.client;
                
                messaging.initialiseSerialisables();

                AppSettings settings = new AppSettings(true);
                settings.setWidth(xsize);
                settings.setHeight(ysize);
                settings.setVSync(true);
                settings.setSamples(8);
                settings.setFullscreen(false);
                settings.setTitle("DeskSim");

                // VR relatert
                settings.put(VRConstants.SETTING_USE_COMPOSITOR, true);
                //settings.put(VRConstants.SETTING_VRAPI, VRConstants.SETTING_VRAPI_OCULUSVR_VALUE);
                settings.put(VRConstants.SETTING_VRAPI, VRConstants.SETTING_VRAPI_OPENVR_VALUE); // The VR api to use (need to be present on the system)
                settings.put(VRConstants.SETTING_DISABLE_VR, false);          // Enable VR
                settings.put(VRConstants.SETTING_ENABLE_MIRROR_WINDOW, false); // Enable Mirror rendering oh the screen (disable to be faster)
                settings.put(VRConstants.SETTING_VR_FORCE, false);            // Not forcing VR rendering if no VR system is found.
                //settings.put(VRConstants.SETTING_GUI_CURVED_SURFACE, false);   // Curve the mesh that is displaying the GUI
                settings.put(VRConstants.SETTING_FLIP_EYES, false);           // Is the HMD eyes have to be inverted.
                settings.put(VRConstants.SETTING_NO_GUI, true);              // enable gui.
                //settings.put(VRConstants.SETTING_GUI_OVERDRAW, true);         // show gui even if it is behind things.
                settings.put(VRConstants.SETTING_DEFAULT_FOV, 108f);          // The default ield Of View (FOV)
                settings.put(VRConstants.SETTING_DEFAULT_ASPECT_RATIO, 1f);   // The default aspect ratio.
                //settings.put(VRConstants.SETTING_SEATED_EXPERIENCE, true);
                settings.setRenderer(AppSettings.LWJGL_OPENGL3); // Setting the renderer. OpenGL 3 is needed if you're using Instance Rendering.

                // The VR Environment.
                // This object is the interface between the JMonkey world (Application, AppState, ...) and the VR specific stuff.
                VREnvironment environment = new VREnvironment(settings);
                environment.initialize();
                //

                // Checking if the VR environment is well initialized 
                // (access to the underlying VR system is effective, VR devices are detected).
                if (environment.isInitialized()) {
                    vrOn = true;

                    // Initialise VR AppState with the VR environment.
                    VRAppState vrAppState = new VRAppState(settings, environment);
                    vrAppState.setFrustrumNearFar(0.1f, 2048f);
                    vrAppState.setMirrorWindowSize(1400, 900);
                    vrAppState.setSettings(settings);

                    // Create the sample application with the VRAppState attached.
                    // There is no constraint on the Application type.
                    //SimpleApplication test = new VRAppStateSample(vrAppState);
                    Program vrProgram = new Program(vrAppState);

                    vrProgram.setShowSettings(false);
                    vrProgram.setPauseOnLostFocus(false);

                    // Sharing settings between app state and application is recommended.
                    vrProgram.setSettings(settings);

                    // Starting the application.
                    vrProgram.start();
                } else // NORMAL STARTUP - NOT VR
                {
                    //logger.severe("Cannot start VR sample application as VR system is not initialized (see log for details)");
                    Program program = new Program();

                    program.setShowSettings(false);
                    program.setDisplayFps(false);
                    program.setDisplayStatView(false);
                    program.setPauseOnLostFocus(false);
                    program.setSettings(settings);

                    //Undecorated
                    if (StartParameters.worldPanelUnDecorated) {
                        System.setProperty("org.lwjgl.opengl.Window.undecorated", "true");
                    }

                    program.start();
                }
            }
        });

        t.start();
    }

    private static void openRealAtcUsbComm() {
        // real  atc se no
        if (StartParameters.realatcseno) {
            System.out.println("SIM configured (config.txt) to run real ATC SE NO\nOpening ATC USB communication...");
            atcMetoder = new ATCMetoder();
            if (!atcMetoder.atcDeviceIsOpen()) {
                System.out.println("NOT able to open ATC USB communication, running simulated ATC");
                StartParameters.realatcseno = false;
            } else {
                System.out.println("ATC USB communication opened succesfully, running real ATC");
                Program.atcMetoder.sendSpeed(Math.abs(0));
            }
        }
        //
    }

    @Override
    public void destroy() {
        if(isServer)
        {
            System.out.println("closing server");
            myServer.close();
        }
        else if(isClient && myClient.isStarted())
        {
            System.out.println("closing client");
            myClient.close();
        }
        super.destroy();
        System.exit(0);
    }

    public static Picture crosshair = new Picture("HUD Picture");   //crosshair for noVRPerson

    // SimpleInit NORMAL
    @Override
    public void simpleInitApp() {

        bulletAppState = new BulletAppState();        // Physics
        //bulletAppState.setDebugEnabled(true);
        stateManager.attach(bulletAppState);     
        assetManager = getAssetManager();
        inputManager = getInputManager();
        rootNode = getRootNode();
        cam = getCamera();
        settings = new AppSettings(true);
        int xsize = StartParameters.worldPanelSizeX;//1600;//1920; //800
        int ysize = StartParameters.worldPanelSizeY;//900;//1199; //600
        settings.setWidth(xsize);
        settings.setHeight(ysize);
        settings.setVSync(true);
        settings.setSamples(8);

        // init all - terrain, infrastructure, vehicle
        init();

        // setup lights
        DirectionalLight sun = new DirectionalLight();
        if (!StartParameters.newLighting) {
            sun.setDirection(new Vector3f(-1, -1, -1).normalizeLocal()); // direction with old lighting
        } else {
            // default sun 45 grader oppå himmelen rett i sør, kan endrast frå scenariet
            if (scenarioSunDirection != null) // dersom solposisjon er definert i scenariet
            {
                sun.setDirection(scenarioSunDirection);
            } else {
                sun.setDirection(new Vector3f(0f, -1, 1).normalizeLocal()); // default direction with new lighting
            }
        }

        sun.setColor(ColorRGBA.White);
        rootNode.addLight(sun);

        AmbientLight al = new AmbientLight();
        if (!StartParameters.newLighting) {
            al.setColor(ColorRGBA.White);
        } else {
            if (scenarioAmbient != null) {
                al.setColor(scenarioAmbient);
            } else {
                float defaultAmbient = 0.2f;
                al.setColor(new ColorRGBA(defaultAmbient, defaultAmbient, defaultAmbient, 0)); // default ambient
            }
        }

        rootNode.addLight(al);

        // camera
        float height = settings.getHeight();
        float width = settings.getWidth();

        if (!vrOn) {
            // general camera settings
            flyCam.setDragToRotate(true);
            cam.setFrustumPerspective(60, width / height, .1f, 1000); // view angle / aspect ratio / near / far
            cam.setLocation(new Vector3f(1200, 115, 925));
            cam.lookAtDirection(new Vector3f(0.0f, 0, 1), new Vector3f(0, 1, 0));

            // flycam
            flyCam.setMoveSpeed(20);
            flyCam.setEnabled(false);
        }

        if (!TRACK_BUILD_MODE) {
            GeometryBatchFactory.optimize(rootNode);
        }

        // changeable objects
        addDynamicObjects();

        // link dependent objects
        linkDependentObjects();

        // init state all objects
        testInitStateAllDynamicObjects();

        //  Initializing VrPerson
        vrPerson = new VrPerson();
        
        // vehicle
        addSimVehicle(/*null*//*observer*/);
        vrVehicle = (SimSimpleVehicle) simVeh;
        
        if (vrPerson.getVrOn())
            vrPerson.toggleCamVR();

        // tooglecam til riktig start kamera i forhold til øvelse
        if (!vrOn && loadDetailedComponents) // start ute
        {
            toggleCamNormal();
            toggleCamNormal();
            toggleCamNormal();
            toggleCamNormal();
        }

        // keys
        initKeys();

        // continous updates i.e flashing
        UpdateTask200 updateTask200 = new UpdateTask200();
        Timer updateTimer200 = new Timer(true);
        updateTimer200.schedule(updateTask200, 200, 200);

        updateTask250 = new UpdateTask250();
        Timer updateTimer250 = new Timer(true);
        updateTimer250.schedule(updateTask250, 250, 250);

        // sky
        Spatial skySpatial = SkyFactory.createSky(
                assetManager, "Textures/Sky/Bright/BrightSky.dds", false);
        skySpatial.rotate(0, 0 * FastMath.DEG_TO_RAD, 0);

        rootNode.attachChild(skySpatial);

        // load nifty
        loadNiftyStuff();
        // test new info system - SWING
        //loadInfo2Stuff();
        //
        // lightsources glow
        if (StartParameters.newLighting) {
            FilterPostProcessor fpp = new FilterPostProcessor(assetManager);
            BloomFilter bloom = new BloomFilter(BloomFilter.GlowMode.Objects);

            bloom.setBlurScale(1);
            //bloom.setDownSamplingFactor(2f); 
            bloom.setBloomIntensity(3);
            //bloom.setExposurePower(10);

            fpp.addFilter(bloom);
            fpp.setNumSamples(8); // antialiasing
            viewPort.addProcessor(fpp);
        }

        // finishing
        System.out.println("SimpleInitApp finished");

        System.gc();

        Runtime rt = Runtime.getRuntime();
        long usedMB = (rt.totalMemory() - rt.freeMemory()) / 1024 / 1024;
        System.out.println("mem tot: " + rt.totalMemory() / 1024 / 1024);
        System.out.println("mem free: " + rt.freeMemory() / 1024 / 1024);
        System.out.println("mem max: " + rt.maxMemory() / 1024 / 1024);
        System.out.println("mem used: " + usedMB);
    }

    private MyXmlCreatorScenario readScenario() {
        // Reading scenario
        System.out.println("Reading scenario");
        String scenarioFil = StartParameters.scenarioName + ".xml";
        System.out.println("Name: " + scenarioFil + " IsStartCondScenario: " + startCondScenario);
        //System.exit(0);
        MyXmlReader.readFile("assets/A_Scenarios/" + scenarioFil);
        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();
        System.out.println("topobj: " + baseObject.getTopObject().getTagName());

        MyXmlCreatorScenario xmlCreatorScenario = new MyXmlCreatorScenario();
        System.out.println("creating scen");
        xmlCreatorScenario.createObjects(baseObject.getTopObject().getObjectList());
        System.out.println("scen finished");

        return xmlCreatorScenario;
    }

    private void init() {
        if(isServer)
        {
            System.out.println("starting server");
            try {
                myServer = Network.createServer(6143);
                myServer.start();
                myServer.addMessageListener(new ServerMessageListener());
            } catch (IOException ex) {
                Logger.getLogger(Program.class.getName()).log(Level.SEVERE, null, ex);
                System.out.println("Server failed");
            }
        }
        else if(isClient)
        {
            try {
                System.out.println("starting client");
                //  Works only with exact local ip address
                //  TODO: Find ip address automatically
                //  TODO: Enter IP here
                myClient = Network.connectToServer("0.0.0.0", 6143);
                myClient.start();
                //trainMoveQueue = new ConcurrentLinkedQueue<TrainMoveMessage>();
                myClient.addMessageListener(new ClientMessageListener());
                
            } catch (IOException ex) {
                Logger.getLogger(Program.class.getName()).log(Level.SEVERE, null, ex);
                System.out.println("client failed");
            }
        }
        
        if (TRACK_BUILD_MODE) {
            tbFrame = new TbFrame(this);
            terrainOperations = new TerrainOperations(rootNode, assetManager);
            tbFrame.getTp().setTbOperations(terrainOperations);
            terrainOperations.setTbPanel(tbFrame.getTp());

            //tcoOperations = new TcoOperations(rootNode, assetManager);
            tcoOperations = new TcoOperations(rootNode, assetManager);
            tcoOperations.setProgram(this);
        } else {
            terrainOperations = new TerrainOperations(rootNode, assetManager);
        }

        // Reading STARTCOND scenario
        if (startCondScenario) {
            MyXmlCreatorScenario startCondXmlCreatorScenario = readScenario();
            String name = startCondXmlCreatorScenario.getStartCondScenarioName();
            StartParameters.altScenarioName = StartParameters.scenarioName;
            StartParameters.scenarioName = name;
            String scenarioFil = StartParameters.scenarioName + ".xml";
            System.out.println("name old: " + StartParameters.altScenarioName);
            System.out.println("name new: " + scenarioFil);

            // parameters from startcondscenario
            simTrainInfo = startCondXmlCreatorScenario.getEti();
            for (String s : startCondXmlCreatorScenario.getStartCondList()) {
                System.out.println("startkond: " + s);
                if (s.equals("tydverg_blue")) {
                    TyDverg.workMode = TyDverg.WORK_MODE_BLUE_LAMPS;
                }
            }

            // alternative slides
            hasAlternativeSlides = hasAltSlides();
        }

        // reading scenario to be RUNNED
        MyXmlCreatorScenario xmlCreatorScenario = readScenario();

        ArrayList<SectionInfo> secInfoList = xmlCreatorScenario.getSectionInfoList();

        if (TRACK_BUILD_MODE) {
            SectionInfo si = secInfoList.get(0);
            si.setName(trackBuildSectionName);
        }

        if (!startCondScenario) // if scenario was not started by startcondscenario, parameters set here
        {
            simTrainInfo = xmlCreatorScenario.getEti();
        }

        // new lighting
        if (xmlCreatorScenario.isNewLighting()) {
            StartParameters.newLighting = true;
            findModelsNewLighting();

            // sunpos
            if (xmlCreatorScenario.getSunPosition() != null) {
                findSunDirectionVector(xmlCreatorScenario.getSunPosition().x, xmlCreatorScenario.getSunPosition().y);
            }

            // ambient
            if (xmlCreatorScenario.getAmbientLightLevel() > 0.1f) {
                scenarioAmbient = new ColorRGBA(xmlCreatorScenario.getAmbientLightLevel(), xmlCreatorScenario.getAmbientLightLevel(),
                        xmlCreatorScenario.getAmbientLightLevel(), 0);
            }

        }

        // StartParameters.newLighting blir satt ved oppstart i TB mode 
        if (TRACK_BUILD_MODE && StartParameters.newLighting) {
            findModelsNewLighting();
        }

        // starttime
        String startTime = xmlCreatorScenario.getStartTime();
        findAndSetScenarioTime(startTime);

        Vector3f prevSecEndPoint = new Vector3f();// 0,0,0

        // load sections
        int k = 0;
        for (SectionInfo si : secInfoList) {
            loadSection(si.getName(), prevSecEndPoint, si.getEndPointNextStartPointIndex(),
                    si.getFirstLineYCorrectionArray(), si.getLastLineYCorrectionArray());

            // hent ut denne seksjonen sitt sluttpunkt slik at det kan brukast som startpunkt for neste seksjon
            prevSecEndPoint = new Vector3f(
                    sectionList.get(k).getAllEndTrackNodes().get(si.getEndPointNextStartPointIndex()).getPoint());
            prevSecEndPoint.y = 0;

            k++;
        }

        // load txp
        workerList = xmlCreatorScenario.getTxpList();
        for (Txp tco : workerList) {
            tco.initAll(assetManager);

            sectionList.get(0).addStateTCO(tco);
        }

        //  load scenario tco
        for (TrackConnectedObject tco : xmlCreatorScenario.getScenarioBasedTcoList()) {
            if (tco instanceof ScenarioBasedTCO) {
                ScenarioBasedTCO tcoSb = ((ScenarioBasedTCO) tco);
                tco.initAll(assetManager);
                tcoSb.updateSectionIndexFromStoredName();
                rootNode.attachChild(tco.getPivot());
                tco.moveToWorldPosition(sectionList.get(tcoSb.getSectionIndex()), assetManager);

                if (tco instanceof UpdateObject) {
                    sectionList.get(0).addStateTCO(tco);
                    updateObjectList.add((UpdateObject) tco);
                }

            }
        }

        // load scenarioEvents
        scenarioEventList.addAll(xmlCreatorScenario.getScenarioEventList());

        // add objects to scenarioevents
        for (ScenarioEvent se : scenarioEventList) {
            for (ScenarioItem si : se.getItemList()) {
                if (si instanceof ScenarioTriggerTrackPos) {
                    // move and transform to world position
                    ScenarioTriggerTrackPos tco = ((ScenarioTriggerTrackPos) si);
                    tco.updateSectionIndexFromStoredName();
                    tco.moveToWorldPosition(sectionList.get(tco.getSectionIndex()), assetManager);
                } else {
                    if (si instanceof ScenarioActionStateChanger) {
                        ((ScenarioActionStateChanger) si).setSectionList(sectionList);
                    } else {
                        if (si instanceof ScenarioActionBaliseErrorBits) {
                            ((ScenarioActionBaliseErrorBits) si).setSectionList(sectionList);
                        } else {
                            if (si instanceof ScenarioActionAutoTrainCommand) {
                                ((ScenarioActionAutoTrainCommand) si).setWorldSystem(this);
                                ((ScenarioActionAutoTrainCommand) si).updateSectionIndexFromStoredName();
                            } else {
                                if (si instanceof ScenarioActionFollowSimTrain) {
                                    ScenarioActionFollowSimTrain safs = ((ScenarioActionFollowSimTrain) si);
                                    for (Txp t : workerList) {
                                        if (t.getId().equals(safs.getTxpId())) {
                                            safs.setTxp(t);
                                            break;
                                        }
                                    }
                                    safs.setAssetManager(assetManager);
                                    safs.setSectionList(sectionList);
                                }
                            }
                        }
                    }
                }
            }
        }

        // connect sections
        ArrayList<TrackNode> allStartNodeList = new ArrayList<TrackNode>();
        ArrayList<TrackNode> allEndNodeList = new ArrayList<TrackNode>();
        for (Section s : sectionList) {
            allStartNodeList.addAll(s.getAllStartTrackNodes());
            allEndNodeList.addAll(s.getAllEndTrackNodes());
        }

        for (TrackNode tns : allStartNodeList) {
            for (TrackNode tne : allEndNodeList) {
                if (tns.getPoint().distance(tne.getPoint()) < 0.5f) // koble
                {
                    tne.neste = tns;
                    tns.forrige = tne;
                    tne.setTraseOvergang(true);
                    tns.setTraseOvergang(true);
                }
            }
        }

        // messageframe
        messageFrame = new MessageFrame();

        // infoframes
        String scenarioInfoFileName = StartParameters.scenarioName + "_rute.png";
        File scenarioInfoFile = new File("assets/A_Scenarios/" + scenarioInfoFileName);

        if (scenarioInfoFile.exists()) {
            System.out.println("Oppretter ruteinfo-vindu: " + scenarioInfoFileName);
            infoFrame = new InfoFrame("assets/A_Scenarios/" + scenarioInfoFileName);
        }
    }

    private void findModelsNewLighting() {
        File folder = new File("assets/Models/");
        File[] listOfFiles = folder.listFiles();

        for (File f : listOfFiles) {
            if (f.getName().contains("_nl")) {
                String[] sa = f.getName().split("\\.");
                if (sa.length == 2 && sa[1].equals("ac")) {
                    modelFilesNL.add(sa[0]);
                }
            }
        }
    }

    // lager sollysretning basert solposisjon angitt i scenariet
    private void findSunDirectionVector(float graderTilt, float graderRotation) {
        scenarioSunDirection = new Vector3f(0, 0, 1);
        float radTilt = graderTilt * FastMath.DEG_TO_RAD;
        float radRotation = graderRotation * FastMath.DEG_TO_RAD;

        Quaternion quatTilt = new Quaternion().fromAngleAxis(radTilt, new Vector3f(1, 0, 0));
        Transform transformTilt = new Transform(quatTilt);
        transformTilt.transformVector(scenarioSunDirection, scenarioSunDirection);

        Quaternion quatRot = new Quaternion().fromAngleAxis(radRotation, new Vector3f(0, 1, 0));
        Transform transformRot = new Transform(quatRot);
        transformRot.transformVector(scenarioSunDirection, scenarioSunDirection);
        scenarioSunDirection.z = -scenarioSunDirection.z;

        System.out.println("SOL scenariedefinert posisjon - grader tilt: " + graderTilt + " :" + graderRotation + " x1: "
                + scenarioSunDirection.x + " y1: " + scenarioSunDirection.y + " z1: " + scenarioSunDirection.z);
    }

    private boolean hasAltSlides() {
        System.out.println("1: " + StartParameters.niftyName);
        System.out.println("2: " + StartParameters.altScenarioName);
        File dir = new File("./assets/A_Scenarios_Content/" + StartParameters.altScenarioName + "&" + StartParameters.niftyName);
        if (!dir.exists()) {
            return false;
        }

        return dir.listFiles().length > 0;
    }

    private KmlSplineTrase etablerKMLTrase(String sectionFile, Vector3f startWorldPoint,
            Vector3f startCorrOffs, Vector3f endCorrOffs) {
        KmlSplineTrase kmlst = new KmlSplineTrase(0, "assets/A_Sectionsfolders/kml/" + sectionFile + ".kml",
                startWorldPoint, startCorrOffs, endCorrOffs);

        // elevation
        AltTextfileReader atr = new AltTextfileReader("assets/A_Sectionsfolders/alt/" + sectionFile + ".alt");
        ArrayList<Vector3f> elevationProfileList = atr.getPointListe();
        if (elevationProfileList != null) {
            KmlSpline spline = kmlst.getSpline();
            spline.etablerElevationProfile(elevationProfileList);
        }

        return kmlst;
    }

    private void findAndSetScenarioTime(String startTime) {
        if (startTime == null) {
            setSimTid(12, 0);
        } else {
            String[] sa = startTime.split(":");
            if (sa.length == 2) {
                try {
                    int h = Integer.parseInt(sa[0]);
                    int m = Integer.parseInt(sa[1]);
                    setSimTid(h, m);
                } catch (NumberFormatException nfe) {
                    setSimTid(12, 0);
                }
            } else {
                setSimTid(12, 0);
            }
        }
    }

    private boolean isNewTerrain(String sectionName) {
        // your directory
        File f = new File("assets/A_Sectionsfolders/terrain_new/");
        File[] files = f.listFiles();

        for (File f1 : files) {

            String s1 = f1.getName().replace("_ter_new.xml", "");
            //System.out.println("file: " + f1.getName() + " " + s1 + " " + sectionName);
            if (s1.equals(sectionName)) {
                return true;
            }
        }

        return false;
    }

    private void extractVector(String s, Vector3f vec) {
        String[] sa = s.split(",");
        if (sa.length != 3) {
            return;
        }

        try {
            float x = Float.parseFloat(sa[0]);
            float y = Float.parseFloat(sa[1]);
            float z = Float.parseFloat(sa[2]);

            vec.x = x;
            vec.y = y;
            vec.z = z;
        } catch (NumberFormatException nfe) {

        }
    }

    private void lesFilStartEndCorrection(Vector3f startCorr, Vector3f endCorr, String name) {
        String startEndCorr = TekstfilLeser.lesFil("assets/A_Sectionsfolders/start_end_corr/" + name + ".cor");
        if (startEndCorr == null) {
            return;
        }

        String s = startEndCorr.replaceAll(" ", "");
        String[] sa1 = s.split(";");

        for (String s1 : sa1) {
            String[] sa2 = s1.split("=");

            if (sa2[0].equals("startcorrection")) {
                extractVector(sa2[1], startCorr);
            } else {
                if (sa2[0].equals("endcorrection")) {
                    extractVector(sa2[1], endCorr);
                }
            }
        }

    }

    private void loadSection(String name, Vector3f startWorldPoint, int endPointIndex,
            float[] firstLineYCorrArray, float[] lastLineYCorrArray) {
        System.out.println("loading section: " + name);
//      TrackElementListXML trackListXML = 
//              xmlLeser.readTrackElementListXML("assets/A_Sectionsfolders/track/" + name + ".xml");

        newTerrain = isNewTerrain(name);

        // les sporelementer
//      ArrayList<TrackElement> trackList = new ArrayList<TrackElement>();
//      for (TrackElementXML tx: trackListXML.getTrackElementListXML())
//      {
//        trackList.add(tx.generateTrackElement());
//      }
        // ny
        MyXmlReader.readFile("assets/A_Sectionsfolders/track/" + name + ".xml");
        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();
        System.out.println("topobj track: " + baseObject.getTopObject().getTagName());
        MyXmlCreatorTRACK xmlCreatorTRACK = new MyXmlCreatorTRACK();
        System.out.println("creating track");
        xmlCreatorTRACK.createObjects(baseObject.getTopObject().getObjectList());
        System.out.println("reading track finished");

        ArrayList<TrackElement> trackList = xmlCreatorTRACK.getTrackList();

        // find highest end z
        float highestEndZ = 0;
        for (TrackElement te : trackList) {
            if (te instanceof Track) {
                if (((Track) te).getEndVertex().z > highestEndZ) {
                    highestEndZ = ((Track) te).getEndVertex().z;
                }
            }
        }

        Vector3f startCorrOffsVec = new Vector3f();
        Vector3f endCorrOffsVec = new Vector3f();
        lesFilStartEndCorrection(startCorrOffsVec, endCorrOffsVec, name);

        // les kml trase
        KmlSplineTrase kmlst = etablerKMLTrase(name, startWorldPoint, startCorrOffsVec, endCorrOffsVec);
        //kmlst.setSectionAndNextSectionData(highestEndZ, -32.7f);

        float vinkelStartDeg = kmlst.finnVinkelIPos(0.01f) * FastMath.RAD_TO_DEG;
        float vinkelEndDeg = kmlst.finnVinkelIPos(highestEndZ - 0.01f) * FastMath.RAD_TO_DEG;
        System.out.println("kml traselengde: " + kmlst.getLengde());
        System.out.println("spor langs trase startvinkel: " + vinkelStartDeg);
        System.out.println("spor langs trase sluttvinkel: " + vinkelEndDeg);

        // generer spor
        for (TrackElement t : trackList) {
            t.init(assetManager, kmlst);
            rootNode.attachChild(t.getPivot());

            if ((t instanceof SwitchTrack) && !(t instanceof CurveTrack)) {
                //rootNode.attachChild( ((SwitchTrack)t).getPivotMovables());
                switchTrackList.add(((SwitchTrack) t));
            }

        }

        // store section data
        Section section = new Section();
        sectionList.add(section);
        section.setName(name);
        section.setTrase(kmlst);

        for (TrackElement t : trackList) {
            section.addTrackNodes(t.getAllTrackNodes());
        }

        // koble sporelementer
        ArrayList<TrackNode> allStartTrackNodes = new ArrayList<TrackNode>();
        for (TrackElement t : trackList) {
            for (TrackNode tn : t.getStartTrackNodes()) {
                allStartTrackNodes.add(tn);
            }
        }

        float trackLength = 0;

        ArrayList<TrackNode> allEndTrackNodes = new ArrayList<TrackNode>();
        for (TrackElement t : trackList) {
            for (TrackNode tn : t.getEndTrackNodes()) {
                allEndTrackNodes.add(tn);

                // finn sporlengde
                if (tn.getTempPoint().z > trackLength) {
                    trackLength = tn.getTempPoint().z;
                }
            }
        }

        System.out.println("Section sporlengde: " + name + " " + trackLength);

        if (trackLength > (kmlst.getLengde() + 50)) {
            System.out.println("Spor er mer enn 50 m lengre enn trase, programmet avsluttes");
            System.exit(0);
        }

        for (TrackNode ts : allStartTrackNodes) {
            for (TrackNode te : allEndTrackNodes) {
                if (ts.getTempPoint().distance(te.getTempPoint()) < 0.5f) {
                    ts.forrige = te;
                    te.neste = ts;
                }
            }
        }

        // generer endelige end og start node lister
        section.generateAllStartTrackNodeList();
        section.generateAllEndTrackNodeList();

        // hent ut switch positioner
        for (TrackElement t : trackList) {
            if ((t instanceof SwitchTrack) && !(t instanceof CurveTrack)) {
                switchPositionerList.add(((SwitchTrack) t).getSwitchPositioner());
                section.addSwitchPositioner(((SwitchTrack) t).getSwitchPositioner());
                section.addSoundTriggers(((SwitchTrack) t).getSoundTriggerList());
            }
        }

        // 
        loadTrackConnectedObjects(section);

        //
        loadTro(section);

        if (!TRACK_BUILD_MODE) {
            // terrain
            if (newTerrain) {
                loadTerrain_NewSystem(section, firstLineYCorrArray, lastLineYCorrArray);
            } else {
                loadTerrain(section);
            }
        } else {
            // test new terrain load - blir denne når new terrain skal innførast
            loadTerrain_NewSystem(section, firstLineYCorrArray, lastLineYCorrArray);

            // trackbuild
            tbFrame.getTp().setActiveSection(section);
        }
    }

    private void loadTerrain_NewSystem(Section section,
            float[] firstLineYCorrArray, float[] lastLineYCorrArray) {
        terrainOperations.clearForNewSection();

        String terrainFile = "assets/A_Sectionsfolders/terrain_new/" + section.getName() + "_ter_new.xml";
        File file = new File(terrainFile);

        if (!file.exists()) {
            System.out.println("Doesn't exist: " + terrainFile);

            if (TRACK_BUILD_MODE) {
                StoreConfig.readAllTBConfig();
                terrainOperations.buildTerrain(section);
            }

            tcoOperations.setTraseVertexList(terrainOperations.getTraseVertexList());
            tcoOperations.setSection(section);

            return;
        }

        // from here and through method if terrain file already exist
        MyXmlReader.readFile(terrainFile);
        //MyXmlReader.readFile("assets/A_Sectionsfolders/tco/st3_tco.xml");
        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();

        System.out.println("TER NEW topobj: " + baseObject.getTopObject().getTagName());
        MyXmlCreatorTER_NEW xmlCreatorTER_NEW = new MyXmlCreatorTER_NEW();
        System.out.println("TER NEW creating tco");
        xmlCreatorTER_NEW.createObjects(baseObject.getTopObject().getObjectList());

        terrainOperations.buildTerrain(section);

        if (TRACK_BUILD_MODE) {
            tcoOperations.setTraseVertexList(terrainOperations.getTraseVertexList());
            tcoOperations.setSection(section);
        }

        Vector3f[] vertexArrayGlobal = xmlCreatorTER_NEW.getVertexArrayGlobal();
        if (vertexArrayGlobal == null) {
            System.out.println("Terrain not found for this section");
            return;
        } else // Y korrigering start og slutt
        {
            if (firstLineYCorrArray != null && firstLineYCorrArray.length == terrainOperations.getNumOfXVertices()) {

                for (int i = 0; i < terrainOperations.getNumOfXVertices(); i++) {
                    vertexArrayGlobal[i].y = firstLineYCorrArray[i];
                }
            }

            if (lastLineYCorrArray != null && lastLineYCorrArray.length == terrainOperations.getNumOfXVertices()) {
                int k = 0;
                for (int i = vertexArrayGlobal.length - terrainOperations.getNumOfXVertices(); i < vertexArrayGlobal.length; i++) {
                    vertexArrayGlobal[i].y = lastLineYCorrArray[k];
                    k++;
                }
            }
        }

        terrainOperations.terrainUpdateAllVertices(vertexArrayGlobal);
        terrainOperations.terrainUpdateAllTextures(xmlCreatorTER_NEW.getgTDTempStorageList());
        terrainOperations.terrainLoadStaticObjects(xmlCreatorTER_NEW.getStodList(), TRACK_BUILD_MODE, section.getTrase().getStartPunkt());
    }

    private void loadTerrain(Section section) {
        System.out.println("reading terrain");

        MyXmlReader.readFile("assets/A_Sectionsfolders/terrain/" + section.getName() + "_ter.xml");
        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();

        System.out.println("topobj: " + baseObject.getTopObject().getTagName());

        Node n1 = new Node();
        MyXmlCreatorTER xmlCreatorTER = new MyXmlCreatorTER();
        xmlCreatorTER.setAssetManager(assetManager);
        xmlCreatorTER.setBulletAppState(bulletAppState);
        xmlCreatorTER.setTrase(section.getTrase());
        //xmlCreatorTER.setRootNode(rootNode);
        xmlCreatorTER.setRootNode(n1);
        System.out.println("creating terrain");
        xmlCreatorTER.createObjects(baseObject.getTopObject().getObjectList());
        System.out.println("terrain finished");

        n1.move(section.getTrase().getStartPunkt());
        rootNode.attachChild(n1);
    }

    private void loadTrackConnectedObjects(Section section) {
        ArrayList<TrackConnectedObject> tcoList = new ArrayList<TrackConnectedObject>();
        section.setTcoList(tcoList);
        ArrayList<TrackConnectedObject> stateTcoList = new ArrayList<TrackConnectedObject>();
        section.setStateTcoList(stateTcoList);

        System.out.println("reading tco: " + section.getName());

        // file exists?
        String filePathName = "assets/A_Sectionsfolders/tco/" + section.getName() + "_tco.xml";
        File f = new File(filePathName);
        if (!f.exists()) {
            return;
        }

        // fil eksisterer
        if (/*!TRACK_BUILD_MODE*/true) {
            MyXmlReader.readFile("assets/A_Sectionsfolders/tco/" + section.getName() + "_tco.xml");
        } else {
            MyXmlReader.readFile("assets/A_Sectionsfolders/tco/" + section.getName() + "_tco_new.xml");
        }

        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();

        System.out.println("topobj: " + baseObject.getTopObject().getTagName());
        MyXmlCreatorTCO xmlCreatorTCO = new MyXmlCreatorTCO();
        System.out.println("creating tco");
        xmlCreatorTCO.createObjects(baseObject.getTopObject().getObjectList());
        System.out.println("reading tco finished");

        // generate tco instance from xml and add to list
        for (TrackConnectedObject tco : xmlCreatorTCO.getTCOList()) {
            // to be removed
//      tco.getTrackPoint().z -= 1806;
//      if (tco.getTrackPoint().z > 0 && tco.getTrackPoint().z < 2500)
//      {
            tcoList.add(tco); //  berre denne står igjen
//      }
            //

            if (tco instanceof UpdateObject) {
                updateObjectList.add(((UpdateObject) tco));
            }

            // balises     
            if (StartParameters.balisesEditable) {
                if (tco instanceof Balise) {
                    noAtcBaliseList.add((Balise) tco);
                }
            }
        }

        // init 3D and trackNode
        for (TrackConnectedObject tco : tcoList) {
            tco.initAll(assetManager);
            rootNode.attachChild(tco.getPivot());
        }

        // stateobjects
        for (TrackConnectedObject tco : tcoList) {
            if (tco.isStateObject()) {
                stateTcoList.add(tco);
            }
        }

        // move and transform to world position
        for (TrackConnectedObject tco : tcoList) {
            tco.moveToWorldPosition(section, assetManager);
        }

        // ERTMS objects inform abour RBC
        for (TrackConnectedObject tco : tcoList) {
            if (tco instanceof ErtmsHastProfil) {
                ((ErtmsHastProfil) tco).setRBC(rbc);
            }
        }

    }

    private void loadTro(Section section) {
        ArrayList<TrackConnectedObject> troList = new ArrayList<TrackConnectedObject>();

        // file exists?
        String filePathName = "assets/A_Sectionsfolders/tro/" + section.getName() + "_tro.xml";
        File f = new File(filePathName);
        if (!f.exists()) {
            return;
        }

        // fil eksisterer
        if (/*!TRACK_BUILD_MODE*/true) {
            MyXmlReader.readFile("assets/A_Sectionsfolders/tro/" + section.getName() + "_tro.xml");
        } else {
            MyXmlReader.readFile("assets/A_Sectionsfolders/tro/" + section.getName() + "_tro_new.xml");
        }

        BaseObjectXML baseObject = MyXmlReader.getBaseObjectXML();

        System.out.println("TRO topobj: " + baseObject.getTopObject().getTagName());
        MyXmlCreatorTCO xmlCreatorTCO = new MyXmlCreatorTCO();
        System.out.println("TRO creating tco");
        xmlCreatorTCO.createObjects(baseObject.getTopObject().getObjectList());

        // generate tco instance from xml and add to list
        for (TrackConnectedObject tco : xmlCreatorTCO.getTCOList()) {
            troList.add(tco);
        }

        // init 3D
        for (TrackConnectedObject tco : troList) {
            tco.initAll(assetManager);
            rootNode.attachChild(tco.getPivot());
        }

        // move and transform to world position
        for (TrackConnectedObject tco : troList) {
            tco.moveToWorldPosition(section, assetManager);
        }

        // legg inn i tco liste for editering
        if (TRACK_BUILD_MODE) {
            for (TrackConnectedObject tco : troList) {
                section.getTcoList().add(tco);
            }
        }

        // ledning
        for (KL kl : xmlCreatorTCO.getKlList()) {
//        KLKomponent k1 = finnKLTro(kl.getPt1(), troList, section.getTrase().getStartPunkt());
//        KLKomponent k2 = finnKLTro(kl.getPt2(), troList, section.getTrase().getStartPunkt());

            KLKomponent k1 = finnKLTroTraseBasert(kl.getT1(), troList, section.getTrase().getStartPunkt());
            KLKomponent k2 = finnKLTroTraseBasert(kl.getT2(), troList, section.getTrase().getStartPunkt());

            if (k1 != null && k2 != null) {
                kl.setK1(k1);
                kl.setK2(k2);
                kl.initAll(assetManager);
                rootNode.attachChild(kl.getPivot());
            }
        }

        // legg inn i kl liste for editering
        if (TRACK_BUILD_MODE) {
            for (KL kl : xmlCreatorTCO.getKlList()) {
                tcoOperations.getKlList().add(kl);
            }
        }

        //Switchengine
        for (SwitchPositioner sp : section.getSwitchPositionerList()) {
            sp.initAll(assetManager);
            rootNode.attachChild(sp.getPivot());
            sp.moveToWorldPosition(section, assetManager);
            section.addStateTCO(sp);
            //updateObjectList.add(sp);
        }

//      // Switch sound triggers
//      for (TrackConnectedObject tst: section.getSoundTriggerList())
//      {
//        tst.initAll(assetManager);
//        tst.moveToWorldPosition(section, assetManager);
//      }
    }

    private KLKomponent finnKLTro(Vector3f p, ArrayList<TrackConnectedObject> kList, Vector3f sectionStartPoint) {
        for (TrackConnectedObject t : kList) {
            if (t instanceof KLKomponent && ((KLKomponent) t).isKlPunkt()) {
                // consider startpoint
                Vector3f klKomponentPoint = ((KLKomponent) t).getWorldPoint();
                klKomponentPoint = klKomponentPoint.subtract(sectionStartPoint);
                //

                //Vector3f p1 = new Vector3f(((KLKomponent)t).getWorldPoint());
                Vector3f p1 = klKomponentPoint;
                Vector3f p2 = new Vector3f(p);
                p1.y = 0;
                p2.y = 0;
                //double d = t.getPoint().distance(p);
                float d = p1.distance(p2);

                if (d < 0.19f) {
                    return ((KLKomponent) t);
                }
            }
        }

        return null;
    }

    private KLKomponent finnKLTroTraseBasert(Vector3f p, ArrayList<TrackConnectedObject> kList, Vector3f sectionStartPoint) {
        for (TrackConnectedObject t : kList) {
            if (t instanceof KLKomponent && ((KLKomponent) t).isKlPunkt()) {
                // consider startpoint
                Vector3f klKomponentPoint = ((KLKomponent) t).getWorldPoint();
                //klKomponentPoint = klKomponentPoint.subtract(sectionStartPoint);
                //

                //Vector3f p1 = new Vector3f(((KLKomponent)t).getWorldPoint());
                Vector3f p1 = new Vector3f(klKomponentPoint);
                Vector3f p2 = new Vector3f(p);
                p1.x = ((KLKomponent) t).getOffsetVector().x;
                p1.y = 0;
                p1.z = ((KLKomponent) t).getTrackPoint().z;
                p2.y = 0;
                //double d = t.getPoint().distance(p);
                float d = p1.distance(p2);

                if (d < 0.19f) {
                    return ((KLKomponent) t);
                }
            }
        }

        return null;
    }

    private void testMoveTco() {
        Section section = sectionList.get(0);
        TrackConnectedObject tco = section.getTcoList().get(0);
        //tco.move3D(new Vector3f(0,0,170), section.getTrase(), assetManager);
        tco.setTrackPoint(new Vector3f(0, 0, 300));
        tco.moveToWorldPosition(section, assetManager);
    }

    private void testSwitchPos(int i) {
        System.out.println("i: " + i + " " + switchPositionerList.size());

        if (i == 1) {
            switchPositionerList.get(0).changeSwitchPosAlpha(0.1f);
        } else {
            switchPositionerList.get(0).changeSwitchPosAlpha(-0.1f);
        }
    }

    private void addSimVehicle(/*Spatial observer*/) {
        TrainCreator tc = null;
        Section secToAddVeh = sectionList.get(
                findSectionIndex(simTrainInfo.getStartSectionName()));

        if (simTrainInfo.getName().equals("SimSimpleAtcErtmsTrain")) {
            if (/*bserver == null*/!vrOn) {
                tc = new TrainCreatorSimSimpleAtcErtmsTrain(rbc, vrPerson.getNoVrCamNodeLok());
            } else {
                tc = new TrainCreatorSimSimpleAtcErtmsTrain(rbc);
            }

            tc.createTrain("locomotive", simTrainInfo);

            simVeh = tc.getMasterVehicle();
            simTrainNode = tc.getMasterVehicle().getPivot();
        } else {
            System.out.println("Program stopped in adding train, train name not found");
            System.exit(0);
        }

        // add vehicles
        int i = 0;
        for (Vehicle v : tc.getVehicleList()) {
            addVehicle(v, tc.getVehicleStartLocation().get(i).z, tc.getVehicleStartLocation().get(i).x, secToAddVeh);
            i++;
        }
    }

    private static Screen niftyScreen;
    private static Element niftyActiveElement;
    private static Nifty nifty;
    private static boolean[] oppgExists = new boolean[8];
    private static boolean[] oppgState = new boolean[8];
    public static boolean moveNiftyInfo1On = false;
    private static int moveNiftyInfo1X = 2;
    private static int moveNiftyInfo1Y = 250;
    public static boolean moveNiftyInfo2On = false;
    private static int moveNiftyInfo2X = 2;
    private static int moveNiftyInfo2Y = 2;
    private static int pointsTotal = 0;
    private static int pointsNow = 0;
    private static int pointsMax = 0;

    // DESSE TO METODANE TILHØYRER TESTING MED SWING INFOSVINDU
    // BEHELD NIFTY FORELØBIG
    private void loadInfo2Stuff() {
        System.out.println("name:" + StartParameters.niftyName);
        if (StartParameters.niftyName == null || StartParameters.niftyName.length() == 0) {
            System.out.println("No Niftyfile defined");
            return;
        }

        infoFrame2 = new InfoFrame2(this);
    }

    public static void showInfo2(String s1, String info) {
        infoFrame2.setVisible(true);
        System.out.println("s1: " + s1 + " info: " + info);

        // reset oppg
        for (int i = 0; i < oppgExists.length; i++) {
            oppgExists[i] = false;
            oppgState[i] = false;
        }

        // extract info
        String image1 = "";
        boolean kj_m_oppg = (StartParameters.niftyName.contains("OPPG") || StartParameters.niftyName.contains("oppg")
                || StartParameters.niftyName.contains("Oppg"));

        String[] sa = info.split("\\s");
        for (String s : sa) {
            String[] sa2 = s.split("=");
            if (sa2.length == 2) {
                if (sa2[0].equals("imagefil")) {
                    image1 = StartParameters.scenarioName + "&"
                            + StartParameters.niftyName + "/" + sa2[1];

                    ImageIcon im = new ImageIcon("assets/A_Scenarios_Content/" + image1);
                    infoFrame2.setNewImage(im);
                } else {
                    if (sa2[0].contains("oppg") && kj_m_oppg) {
                        int i = findIndex(sa2[0]) - 1;
                        oppgExists[i] = true;
                        if (sa2[1].equals("true")) {
                            oppgState[i] = true;
                        }
                    }
                }
                // osv andre parametere
            }
        }
    }

    // NIFTY
    private void loadNiftyStuff() {
        if (StartParameters.niftyName == null || StartParameters.niftyName.length() == 0) {
            System.out.println("No Niftyfile defined");
            return;
        }

        //String niftyFile = "Interface/nifty_" + StartParameters.scenarioName +  "&" + StartParameters.niftyName + ".xml";
        // Felles nifty-fil 16.05.17
        String niftyFile = "Interface/nifty1.xml";

        System.out.println("niftyfile: " + niftyFile);
        File f = new File("assets/" + niftyFile);
        if (!f.exists()) {
            System.out.println("Defined niftyfile not found");
            return;
        }

        NiftyJmeDisplay niftyDisplay = new NiftyJmeDisplay(
                assetManager, inputManager, audioRenderer, guiViewPort);
        /**
         * Create a new NiftyGUI object
         */
        nifty = niftyDisplay.getNifty();
        /**
         * Read your XML and initialize your custom ScreenController
         */
        //nifty.fromXml("Interface/screen.xml", "start");
        //nifty.fromXml("Interface/screen.xml", "start", new NiftyScreenController(""));
        nifty.fromXml(niftyFile, "start", new NiftyScreenController(""));
        // attach the Nifty display to the gui view port as a processor
        guiViewPort.addProcessor(niftyDisplay);

        niftyScreen = nifty.getScreen("start");

        // hide nifty info 1
        hideNiftyInfo1();

        // info (rute) vindu
        String scenarioInfoFileName = StartParameters.scenarioName + "_rute.png";
        File scenarioInfoFile = new File("assets/A_Scenarios/" + scenarioInfoFileName);

        if (scenarioInfoFile.exists()) {
            infoFrame.setVisible(false);
            infoFrame = null;
            showNiftyInfo2();
        } else {
            hideNiftyInfo2();
        }
    }

    private void showNiftyInfo2() {
        Element eni2 = niftyScreen.findElementById("niftyinfo2");
        eni2.setPaddingLeft(new SizeValue((moveNiftyInfo2X + "px")));
        eni2.setPaddingTop(new SizeValue((moveNiftyInfo2Y + "px")));
        String scenarioName = StartParameters.scenarioName;
        NiftyImage newImage = nifty.getRenderEngine().createImage(niftyScreen, "A_Scenarios/" + scenarioName + "_rute.png", false);
        Element ei2 = niftyScreen.findElementById("image2");
        ei2.setConstraintWidth(new SizeValue(("" + newImage.getWidth())));
        ei2.setConstraintHeight(new SizeValue(("" + newImage.getHeight())));
        ei2.getRenderer(ImageRenderer.class).setImage(newImage);
        niftyScreen.layoutLayers();
        eni2.show();
    }

    private void hideNiftyInfo2() {
        Element eni2 = niftyScreen.findElementById("niftyinfo2");
        eni2.hide();
    }

    public static void hideAllNiftyInfoAndStop() {
        hideNiftyInfo1();
        StopApplication();
    }

    public static void hideAllNiftyInfoAndContinue() {
        boolean search = true;
        int i = 1;
        while (search) {
            String c1 = "cb" + i;
            String c2 = "cb" + i + "R";
            String l1 = "l" + i;
            Element elm1 = niftyActiveElement.findElementById(c1);
            Element elm2 = niftyActiveElement.findElementById(c2);

            if (elm1 != null) {
                CheckBox cb = niftyActiveElement.findNiftyControl(c1, CheckBox.class);
                System.out.println("cb: " + cb.getId() + " " + niftyActiveElement.getId());
            } else {
                if (elm2 != null) {
                    CheckBox cb = niftyActiveElement.findNiftyControl(c2, CheckBox.class);
                    System.out.println("cb: " + cb.getId());
                    Label l = niftyActiveElement.findNiftyControl(l1, Label.class);
                    l.setColor(new de.lessvoid.nifty.tools.Color("#00ff00ff"));
                } else {
                    search = false;
                }
            }

            i++;
        }

//      if (true)
//        return;
        hideNiftyInfo1();

        setPlay(true);
    }

    public static void hideNiftyInfo1() {
        niftyActiveElement = null;
//      for (Element elm: niftyScreen.getLayerElements())
//      {
//        elm.hide();
//      } 
        ScrollPanel scp1 = niftyScreen.findNiftyControl("scrollbarPanelId", ScrollPanel.class);
        scp1.setVerticalPos(0);
        scp1.setHorizontalPos(0);

        Element eni1 = niftyScreen.findElementByName("niftyinfo1");
        eni1.hide();
    }

    public static void showNiftyInfo1(String niftyId, String info) {
        if (niftyId == null || niftyId.equals("")) {
            System.out.println("No Niftyid given");
            return;
        }

        System.out.println("Show Niftyfreeze: " + niftyId + " " + niftyScreen);
        Element ne = niftyScreen.findElementById(niftyId);
        if (ne == null) {
            System.out.println("Nifty element " + niftyId + " not found");
            return;
        }

        hideNiftyInfo1();

        // reset oppg
        for (int i = 0; i < oppgExists.length; i++) {
            oppgExists[i] = false;
            oppgState[i] = false;
        }

        // extract info
        String image1 = "";
        boolean kj_m_oppg = (StartParameters.niftyName.contains("OPPG") || StartParameters.niftyName.contains("oppg")
                || StartParameters.niftyName.contains("Oppg"));

        String useThisScenarioName = StartParameters.scenarioName;
        if (hasAlternativeSlides) {
            useThisScenarioName = StartParameters.altScenarioName;
        }

        String[] sa = info.split("\\s");
        for (String s : sa) {
            String[] sa2 = s.split("=");
            if (sa2.length == 2) {
                if (sa2[0].equals("imagefil")) {
                    image1 = /*StartParameters.scenarioName*/ useThisScenarioName + "&"
                            + StartParameters.niftyName + "/" + sa2[1];
                } else {
                    if (sa2[0].contains("oppg") && kj_m_oppg) {
                        int i = findIndex(sa2[0]) - 1;
                        oppgExists[i] = true;
                        if (sa2[1].equals("true")) {
                            oppgState[i] = true;
                        }
                    }
                }
                // osv
            }
        }

        // layout info 
        ne.setPaddingLeft(new SizeValue((moveNiftyInfo1X + "px")));
        ne.setPaddingTop(new SizeValue((moveNiftyInfo1Y + "px")));

        // load the new image
        NiftyImage newImage = nifty.getRenderEngine().createImage(niftyScreen, "A_Scenarios_Content/" + image1, false);

        Element element = niftyScreen.findElementById("image1");

        element.setConstraintWidth(new SizeValue(("" + newImage.getWidth())));
        element.setConstraintHeight(new SizeValue(("" + newImage.getHeight())));
        element.getRenderer(ImageRenderer.class).setImage(newImage);

        // change the image with the ImageRenderer
        niftyScreen.layoutLayers();

        // vis nifty
        niftyActiveElement = ne;
        ne.show();

        // manage points
        pointsNow = 10;

        // manage oppg checkboxes
        Label lcheck = niftyActiveElement.findNiftyControl("lcheck", Label.class);
        lcheck.setText("");
        Label lpoints = niftyActiveElement.findNiftyControl("lpoints", Label.class);
        lpoints.setText("");

        for (int i = 0; i < oppgExists.length; i++) {
            CheckBox cb = niftyActiveElement.findNiftyControl("cb" + (i + 1), CheckBox.class);
            cb.uncheck();
            Label l = niftyActiveElement.findNiftyControl("l" + (i + 1), Label.class);
            if (oppgExists[i]) {
                cb.enable();
                l.setColor(new de.lessvoid.nifty.tools.Color("#00ff00ff"));
            } else {
                cb.disable();
                l.disable();
                l.setColor(new de.lessvoid.nifty.tools.Color("#000000ff"));
            }
        }

        Element checkB = niftyScreen.findElementByName("bcheck");
        Element startB = niftyScreen.findElementByName("bstart");

        if (oppgExists[0]) {
            checkB.enable();
            startB.disable();
        } else {
            checkB.disable();
            startB.enable();
        }
    }

    public void moveNiftyInfo1(int dx, int dy) {
        Element eni1 = niftyScreen.findElementByName("niftyinfo1");
        moveNiftyInfo1X += dx;
        moveNiftyInfo1Y -= dy;

        eni1.setPaddingLeft(new SizeValue(("" + moveNiftyInfo1X)));
        eni1.setPaddingTop(new SizeValue(("" + moveNiftyInfo1Y)));
        niftyScreen.layoutLayers();
    }

    public void moveNiftyInfo2(int dx, int dy) {
        Element eni2 = niftyScreen.findElementByName("niftyinfo2");
        moveNiftyInfo2X += dx;
        moveNiftyInfo2Y -= dy;

        eni2.setPaddingLeft(new SizeValue(("" + moveNiftyInfo2X)));
        eni2.setPaddingTop(new SizeValue(("" + moveNiftyInfo2Y)));
        niftyScreen.layoutLayers();
    }

    public static void checkNiftyQuiz() {
        Label lcheck = niftyActiveElement.findNiftyControl("lcheck", Label.class);
        Label lpoints = niftyActiveElement.findNiftyControl("lpoints", Label.class);
        Element startB = niftyScreen.findElementByName("bstart");
//      startB.disable();
        Element checkB = niftyScreen.findElementByName("bcheck");

        boolean korrekt = true;
        for (int i = 0; i < oppgExists.length; i++) {
            CheckBox cb = niftyActiveElement.findNiftyControl("cb" + (i + 1), CheckBox.class);
            if (cb.isChecked() != oppgState[i]) {
                korrekt = false;
            }
        }

        if (korrekt) {
            lcheck.setText("KORREKT");
            startB.enable();
            checkB.disable();

            // points
            pointsTotal += pointsNow;
            pointsMax += 10;
            lpoints.setText("Poeng oppnådd tilsammen: " + pointsTotal + " av " + pointsMax);
        } else {
            lcheck.setText("PROV IGJEN, EN ELLER FLERE FEIL");

            // points
            if (pointsNow > 7) {
                pointsNow -= 2;
            } else {
                if (pointsNow > 0) {
                    pointsNow -= 1;
                }
            }

            lpoints.setText("Poeng ved riktig svar på neste forsøk: " + pointsNow);
        }
    }

    private static int findIndex(String s) {
        if (!s.contains("oppg")) {
            return 0;
        }

        if (!(s.length() > 4)) {
            return 0;
        }

        String s2 = s.charAt(4) + "";

        try {
            return Integer.parseInt(s2);
        } catch (NumberFormatException nfe) {
            return 0;
        }
    }

    public static void hideNiftyInfo(String niftyId) {
        System.out.println("Hide Niftyfreeze: " + niftyId);
        hideNiftyInfo1();
    }

    public static boolean play = true;
    private static boolean stopAudio = false;
    private static boolean startAudio = false;
    public static long tidDif;
    private static long timeAtPause;

    public static void setPlay(boolean p) {
        play = p;
        if (play) {
            SkalHastPanel.setPauseSymbol();
            startAudio = true;
            tidDif = System.currentTimeMillis() - timeAtPause;
        } else {
            SkalHastPanel.setPlaySymbol();
            stopAudio = true;
            timeAtPause = simTid.getTimeInMillis();
        }

    }

    // set tid fra scenarie
    private static void setSimTid(int hour, int minute) {
        simTid.set(2010, 1, 1, hour, minute, 0);
        tidDif = System.currentTimeMillis() - simTid.getTimeInMillis();
    }

    public static void updateSimTid() {
        simTid.setTimeInMillis(System.currentTimeMillis() - tidDif);
    }

    public static boolean isPlay() {
        return play;
    }

    private boolean add = false;
    public static boolean spvMoving = false;
    //public static int spvMovingCounter = 0;
    public static boolean manualStateUpdate = false;
    public static TrackConnectedObject manualStateUpdateTco = null;
    public static int manualState = 0;

    private float scenarioTimerCounter = 0;
    private static final float SCENARIO_TIMER_INTERVAL = 2.0f; // seconds
    private boolean autoVehicleListBusy = false;

    private float functionsUpdateCounter1 = 0f;
    private static final float FUNCTIONS_TIMER_INTERVAL_1 = 0.250f; // seconds

//    private float functionsUpdateCounter2 = 0f;
//    private static final float FUNCTIONS_TIMER_INTERVAL_2 = 0.200f; // seconds
    /* Use the main event loop to trigger repeating actions. */
    @Override
    public void simpleUpdate(float tpf) {
        // if vr - 
        // Det viser seg at oppdatering av bilde i VR heng 1 frame etter øvrig forflytting av objekter
        // Dette medfører at jo fortare toget kjører jo meir vibrering blir det i togmdellen og tilhøyrande element eks atc panel, spaker osv
        //
        // Programmet er no implementert med i VR at forflytting av toget sin forflytting blir lagt 1 frame forsinka
        // Dette fjerner store deler av vibrasjonsproblemet så denne metoden kan i no fjernast, men bidrar muligens til
        // endå bedre stabilitet i bildet sp den får stå foreløbig.
        if (vrOn) {
            if (tpf < 0.013f || tpf > 0.007f) {
                tpf = 0.010f;
            }
        }

        // trains
        if (play) {
            Vehicle.secsSinceLastFrame = tpf;
            simVeh.tickMain();

            // auto vehicle
            autoVehicleListBusy = true;
            for (Vehicle v : autoVehicleList) {
                v.tickMain();
            }
            autoVehicleListBusy = false;

            for (Vehicle v : stVehicleList) {
                v.tick();
            }

            // if vr - kamera i førerrom vr
            if (vrOn) {
                vrPerson.setVrObserverBaseLok(simVeh.getPivot().getWorldRotation(), simVeh.getVehicleLocationVector());
            }

            // audio
            if (startAudio) {
                startAudio = false;
                for (MyAudioNode an : vehicleAudioList) {
                    if (an.isLooping() && an.isPlaying()) // do not restart point based sounds
                    {
                        an.play();
                    }
                }
            }
        } else {
            // audio
            if (stopAudio) {
                stopAudio = false;
                for (MyAudioNode an : vehicleAudioList) {
                    if (!an.isPlayWhilePause()) {
                        an.pause();
                    }
                }
            }

            // pause related update of vehicle - used for atc startup sound when paused
            simVeh.updateTickWhilePause();
        }

        // switch movement
        if (spvMoving) {
            for (SwitchPositioner s : switchPositionerList) {
                if (s.isMoving()) {
                    s.updateSwitchMovement(tpf);
                }
            }

//      spvMovingCounter++;
//
//      if (spvMovingCounter == 250)
//      {
//        spvMovingCounter = 0;
//        spvMoving = false;
//      }
        }

        // scenario events updates
        scenarioTimerCounter += tpf;
        if (scenarioTimerCounter > SCENARIO_TIMER_INTERVAL) {
            checkScenarioEvents();
            scenarioTimerCounter = 0;

        }

        // manual state update
        if (manualStateUpdate) {
            manualStateUpdateTco.setState(manualState);
            manualState = 0;
            manualStateUpdate = false;
            manualStateUpdateTco = null;
        }

        // FUNCTIONS UPDATER 1
        functionsUpdateCounter1 += tpf;
        if (functionsUpdateCounter1 > FUNCTIONS_TIMER_INTERVAL_1) // resetter timer
        {
            simVeh.functionsUpdateCh1();

            functionsUpdateCounter1 = functionsUpdateCounter1 - FUNCTIONS_TIMER_INTERVAL_1;
        }

//      // FUNCTIONS UPDATER 2 - ikkje tatt ibruk
//      functionsUpdateCounter2 += tpf;
//      if (functionsUpdateCounter2 > FUNCTIONS_TIMER_INTERVAL_2) // resetter timer
//      {
//        //updateFlashTick();
//        
//        functionsUpdateCounter2 = functionsUpdateCounter2- FUNCTIONS_TIMER_INTERVAL_2;
//      }
        // TRACKBUILDER
        if (TRACK_BUILD_MODE) {
            if (tbUpdatePosRelated) {
                tcoWaitingToUpdatePosRelated.moveToWorldPosition(sectionList.get(0), assetManager);
                tbUpdatePosRelated = false;
            }

            if (tbUpdateTcoDelete) {
                if (tcoWaitingToBeDeleted != null) {
                    tcoOperations.deleteTco(tcoWaitingToBeDeleted);
                } else {
                    if (stodWaitingToBeDeleted != null) {
                        terrainOperations.deleteStod(stodWaitingToBeDeleted);
                    }
                }
                tbUpdateTcoDelete = false;
            }

            if (tbUpdateKlDelete) {
                tcoOperations.deleteKL(klWaitingToBeDeleted);
                tbUpdateKlDelete = false;
            }
            if (tbUpdateAttachToRootNode1) {
                rootNode.attachChild(pivotWaitingToBeAttachedToRootNode1);
                pivotWaitingToBeAttachedToRootNode1 = null;
                tbUpdateAttachToRootNode1 = false;
            }
            if (tbUpdateAttachToRootNode2) {
                rootNode.attachChild(pivotWaitingToBeAttachedToRootNode2);
                pivotWaitingToBeAttachedToRootNode2 = null;
                tbUpdateAttachToRootNode2 = false;
            }
        }

        // if vr
        if (/*vrOn*/loadDetailedComponents) {
            //vrVehicle.checkKobbelCollision();
            for (Vehicle vehicle : stVehicleList) {
                vehicle.collision();
            }
        }

        vrPerson.update();
        
        if(isServer)
        {
            if(myServer.hasConnections())
            {
                timeSinceUpdate += tpf;
                float newSpeed = simVeh.getSpeedKmh();
                float newOdom = simVeh.getOdometer();
                int newDir = simVeh.getDirection();
                if(!(newSpeed == lastSpeed && newOdom == lastOdom && newDir == lastDir) || timeSinceUpdate > 0.5f)
                {
                    timeSinceUpdate = 0;
                    myServer.broadcast(new TrainMoveMessage(newSpeed, newOdom, newDir));
                    lastSpeed = newSpeed;
                    lastOdom = newOdom;
                    lastDir = newDir;
                }
            }
            
            VrPersonMoveMessage m = vrPersonMoveQueue;
            if(m != null)
            {
                vrPerson.setPos(m.getPos());
                vrPerson.setRot(m.getRot());
                vrPersonMoveQueue = null;
            }
        }

        if(isClient)
        {
            if(myClient.isConnected())
            {
                timeSinceUpdate += tpf;
                Vector3f newPos = new Vector3f();
                Vector3f newRot = new Vector3f();
                
                newPos.set(vrPerson.getPos());
                newRot.set(vrPerson.getRot());
                if(!(newPos == lastPos && newRot == lastRot) || timeSinceUpdate > 0.5f)
                {
                    timeSinceUpdate = 0;
                    System.out.println(lastPos);
                    myClient.send(new VrPersonMoveMessage(newPos, newRot));
                    lastPos.set(newPos);
                    lastRot.set(newRot);
                    System.out.println(lastPos);
                    System.out.println("Message sent");
                }
            }
            
            TrainMoveMessage m = trainMoveQueue;
            if(m != null)
            {
                simVeh.setSpeedKmh(m.getSpeed());
                simVeh.setOdometer(m.getOdom());
                simVeh.setDirection(m.getDir());
                trainMoveQueue = null;
            }
        }
    }

    // lagt på is
    private void linkDependentObjects() {
        for (UpdateObject uo : updateObjectList) {
            if (uo instanceof TrackConnectedObject) {
                TrackConnectedObject tco = ((TrackConnectedObject) uo);
                if (tco.isUpdateOthers()) {
                    tco.createUpdateOthersList();
                }
            }
        }

//      // test
//      for (UpdateObject uo: updateObjectList)
//      {
//        if (uo instanceof TrackConnectedObject)
//        {
//          TrackConnectedObject tco = ((TrackConnectedObject)uo);
//          if (tco.isUpdateOthers())
//          { 
//            System.out.println("TCO: " + tco.getClass() + " " + tco.getTrackNode().getPos());
//            for (TrackConnectedObject tco2: tco.getUpdateOthersList())
//              System.out.println(" to be upd: " + tco2.getClass() + " " + tco2.getTrackNode().getPos());
//          }
//        }
//      }
//      
//      System.exit(0);
    }

    private void addDynamicObjects() {
        // updateobjects
        for (UpdateObject uo : updateObjectList) {
            if (uo instanceof TrackConnectedObject) {
                TrackConnectedObject tco = ((TrackConnectedObject) uo);
                if (tco.getPivotChangeable() != null) {
                    rootNode.attachChild(tco.getPivotChangeable());
                }

            }
        }

        // workers
        for (Txp t : workerList) {
            rootNode.attachChild(t.getPivotChangeable());
            t.updateSectionIndexFromStoredName();
            t.moveToWorldPosition(sectionList.get(t.getSectionIndex()), assetManager);
        }

        // moving parts of switch track
        for (SwitchTrack st : switchTrackList) {
            rootNode.attachChild(st.getPivotMovables());

            if (st.getSwitchPositioner().isLokalStiller()) {
                rootNode.attachChild(st.getSwitchPositioner().getPivotChangeable());
            }
        }

        // codePlugBox balises
        if (StartParameters.balisesEditable) {
            for (Balise b : noAtcBaliseList) {
                rootNode.attachChild(b.getPivotChangeable());
            }
        }
    }

    private void testInitStateAllDynamicObjects() {
        for (UpdateObject uo : updateObjectList) {
            if (uo instanceof TrackConnectedObject) {
                TrackConnectedObject tco = ((TrackConnectedObject) uo);
                if (tco.getTypeIndex() == NoFS.TYPE_INDEX) {
                    tco.setState(23);
                } else {
                    if (tco.getTypeIndex() == NoHS3.TYPE_INDEX) {
                        if (tco instanceof NoHS3) {
                            tco.setState(20);// 22
                        }
                        if (tco instanceof NoHS2) {
                            tco.setState(20);
                        }
                    }
                }
            }
        }
    }

    private int findSectionIndex(String sectionName) {
        int k = 0;
        for (Section s : sectionList) {
            if (s.getName().equals(sectionName)) {
                return k;
            }
            k++;
        }

        return 0;
    }

    public void addAutoTrain1FromScen(float vehStPos, float vehStX, String vehId, String type, int sectionIndex) {
        System.out.println("Adding autotra: " + vehStPos + " " + vehStX + " " + vehId + " " + sectionIndex + " " + type);
        if (type == null || type.equals("")) {
            add3VognNJTog(vehStPos, vehStX, vehId, type, sectionIndex);
        } else // if - different types
        {
            addVogn(vehStPos, vehStX, vehId, type, sectionIndex);
        }
    }

    // NJ tog 3 vogner
    private void add3VognNJTog(float vehStPos, float vehStX, String vehId, String type, int sectionIndex) {
        AutoVehicle1 av1 = new AutoVehicle1("wagon", "tog_ertms_3.ac");
        av1.setId("");
        av1.setyPos(0.0f);
        //av1.setLength(25);
        //av1.setHarStigtrinn(false);

        AutoVehicle1 av2 = new AutoVehicle1("wagon", "tog_ertms_2.ac");
        av2.setId(vehId);
        av2.setSpeedKmh(0);
        av2.setyPos(0.0f);
        //av2.setLength(25);
        //av2.setHarStigtrinn(false);

        AutoVehicle1 av3 = new AutoVehicle1("wagon", "tog_ertms_1.ac");
        av3.setId("");
        av3.setyPos(0.0f);
        //av3.setLength(25);
        //av3.setHarStigtrinn(false);

        Section secToAddVehIndex = sectionList.get(sectionIndex);

        addVehicle(av1, vehStPos - 25, vehStX, secToAddVehIndex);
        addVehicle(av2, vehStPos, vehStX, secToAddVehIndex);
        addVehicle(av3, vehStPos + 25, vehStX, secToAddVehIndex);

        //av2.getKobbel1().kobleMed(av1.getKobbel2());
        //av2.getKobbel2().kobleMed(av3.getKobbel1());
        //av2.connectTo1(av1);
        //av2.connectTo2(av3);
        boolean prevPlay = play;
        play = false;

        while (autoVehicleListBusy) {
            Logg.addLoggLine("AutoVehicleList while loop");
        } // wait
        autoVehicleList.add(av2);
        fullVehicleList.add(av2);

        play = prevPlay;
    }

    public static ArrayList<Vehicle> stVehicleList = new ArrayList<>();

    private void addVogn(float vehStPos, float vehStX, String vehId, String type, int sectionIndex) {
        Vehicle v = new Vehicle("wagon");
        //vogn1 = v;
        //stVogn1 = v;
        v.setId("");
        v.setyPos(0);
        //v.setLength(25);

        Section secToAddVehIndex = sectionList.get(sectionIndex);

        addVehicle(v, vehStPos, vehStX, secToAddVehIndex);
    }

    public static void oppdaterStartEndKobbel() {
        vrVehicle.updateStartEndKobbelTog();
    }

    public static void updateAirCouplings() {
        vrVehicle.UpdateAirCouplings();
    }

    public static void updateCouplings() {
        vrVehicle.UpdateCouplings();
    }

    public static void ibuttStopp() {
        vrVehicle.setSpeedKmh(0);
    }

    private void addVehicle(Vehicle v1, float vehStPos, float vehStX, Section secToAddVeh) {
        startTrackNode = secToAddVeh.findClosestTrackNodeTraseVertex(new Vector3f(vehStX, 0, vehStPos));

        TrackNode tn1 = startTrackNode;
        TrackNode tn2 = startTrackNode.neste;
        TrackNode tn3 = startTrackNode.neste.neste;

        tn1.neste = v1.getT1();
        v1.getT1().forrige = tn1;
        v1.getT1().neste = tn2;
        tn2.forrige = v1.getT1();

        tn2.neste = v1.getT2();
        v1.getT2().forrige = tn2;
        v1.getT2().neste = tn3;
        tn3.forrige = v1.getT2();

        v1.setOdometer(vehStPos);
        //v1.getCoupling1().setTarget( vrObserver.getWorldTranslation() );
        //v1.getCoupling2().setTarget( vrObserver.getWorldTranslation() );
        v1.tick();
        v1.tick(); // to gonger pga 1 frame forsink i VR

        rootNode.attachChild(v1.getPivot());

        // add audios
        vehicleAudioList.addAll(v1.getVehicleAudioList());
        //

        //simTrainNode = v1.getPivot();
        // add vehicle to scenario items
        for (ScenarioEvent se : scenarioEventList) {
            for (ScenarioItem si : se.getItemList()) {
                // speed trigger
                if (si instanceof ScenarioTriggerSpeed) {
                    if (v1.getId().equals(((ScenarioTriggerSpeed) si).getVehicleId())) {
                        ((ScenarioTriggerSpeed) si).setVehicle(v1);
                    }

                } // system action
                else {
                    if (si instanceof ScenarioActionSystem) {
                        if (v1.getId().equals(((ScenarioActionSystem) si).getVehicleId())) {
                            if (v1 instanceof SimSimpleVehicle) {
                                ((ScenarioActionSystem) si).setVehicle((SimSimpleVehicle) v1);
                            }
                        }
                    } else {
                        if (si instanceof ScenarioActionAutoTrainCommand) {
                            if (v1.getId().equals(((ScenarioActionAutoTrainCommand) si).getVehicleId())) {
                                ((ScenarioActionAutoTrainCommand) si).setVehicle(v1);
                            }
                        } else {
                            if ((si instanceof ScenarioActionFollowSimTrain) && (v1 instanceof SimSimpleVehicle)) {
                                ((ScenarioActionFollowSimTrain) si).setV(v1);
                            }
                        }
                    }
                }

            }
        }

        // to to updatelist
        if (v1 instanceof UpdateObject) {
            updateObjectList.add((UpdateObject) v1);
        }

        // add to static vehicle list
        stVehicleList.add(v1);
        fullVehicleList.add(v1);
    }

    /**
     * Custom Keybinding: Map named actions to inputs.
     */
    private void initKeys() {
        // You can map one or several inputs to one named action
        inputManager.addMapping("trig", new KeyTrigger(KeyInput.KEY_P));
        inputManager.addMapping("spvtestpluss", new KeyTrigger(KeyInput.KEY_V));
        inputManager.addMapping("spvtestminus", new KeyTrigger(KeyInput.KEY_B));
        inputManager.addMapping("toggleCam", new KeyTrigger(KeyInput.KEY_K));
        inputManager.addMapping("flyCamSpeedUp", new KeyTrigger(KeyInput.KEY_R));
        inputManager.addMapping("flyCamSpeedDown", new KeyTrigger(KeyInput.KEY_E));
        inputManager.addMapping("space", new KeyTrigger(KeyInput.KEY_SPACE));
        inputManager.addMapping("manStyr", new KeyTrigger(KeyInput.KEY_F1));

        inputManager.addMapping("skalhastOpp", new KeyTrigger(KeyInput.KEY_ADD));
        inputManager.addMapping("skalhastNed", new KeyTrigger(KeyInput.KEY_SUBTRACT));
        inputManager.addMapping("hoyningsknapp", new KeyTrigger(KeyInput.KEY_MULTIPLY));

        inputManager.addMapping("restartUpdate", new KeyTrigger(KeyInput.KEY_F4));
        inputManager.addMapping("hopp", new KeyTrigger(KeyInput.KEY_H));

        // numbers
        inputManager.addMapping("0", new KeyTrigger(KeyInput.KEY_NUMPAD0));
        inputManager.addMapping("0", new KeyTrigger(KeyInput.KEY_0));
        inputManager.addMapping("1", new KeyTrigger(KeyInput.KEY_NUMPAD1));
        inputManager.addMapping("1", new KeyTrigger(KeyInput.KEY_1));
        inputManager.addMapping("2", new KeyTrigger(KeyInput.KEY_NUMPAD2));
        inputManager.addMapping("2", new KeyTrigger(KeyInput.KEY_2));
        inputManager.addMapping("3", new KeyTrigger(KeyInput.KEY_NUMPAD3));
        inputManager.addMapping("3", new KeyTrigger(KeyInput.KEY_3));
        inputManager.addMapping("4", new KeyTrigger(KeyInput.KEY_NUMPAD4));
        inputManager.addMapping("4", new KeyTrigger(KeyInput.KEY_4));
        inputManager.addMapping("5", new KeyTrigger(KeyInput.KEY_NUMPAD5));
        inputManager.addMapping("5", new KeyTrigger(KeyInput.KEY_5));
        inputManager.addMapping("6", new KeyTrigger(KeyInput.KEY_NUMPAD6));
        inputManager.addMapping("6", new KeyTrigger(KeyInput.KEY_6));
        inputManager.addMapping("7", new KeyTrigger(KeyInput.KEY_NUMPAD7));
        inputManager.addMapping("7", new KeyTrigger(KeyInput.KEY_7));
        inputManager.addMapping("8", new KeyTrigger(KeyInput.KEY_NUMPAD8));
        inputManager.addMapping("8", new KeyTrigger(KeyInput.KEY_8));
        inputManager.addMapping("9", new KeyTrigger(KeyInput.KEY_NUMPAD9));
        inputManager.addMapping("9", new KeyTrigger(KeyInput.KEY_9));
        inputManager.addMapping("x", new KeyTrigger(KeyInput.KEY_X));
        inputManager.addMapping("y", new KeyTrigger(KeyInput.KEY_Y));
        inputManager.addMapping("z", new KeyTrigger(KeyInput.KEY_Z));

        //  Directional input
        inputManager.addMapping("up", new KeyTrigger(KeyInput.KEY_W), new KeyTrigger(KeyInput.KEY_UP));
        inputManager.addMapping("left", new KeyTrigger(KeyInput.KEY_A), new KeyTrigger(KeyInput.KEY_LEFT));
        inputManager.addMapping("down", new KeyTrigger(KeyInput.KEY_S), new KeyTrigger(KeyInput.KEY_DOWN));
        inputManager.addMapping("right", new KeyTrigger(KeyInput.KEY_D), new KeyTrigger(KeyInput.KEY_RIGHT));

        // Add the names to the action listener.
        inputManager.addListener(actionListener, "trig");
        inputManager.addListener(actionListener, "spvtestpluss");
        inputManager.addListener(actionListener, "spvtestminus");
        inputManager.addListener(actionListener, "toggleCam");
        inputManager.addListener(actionListener, "flyCamSpeedUp");
        inputManager.addListener(actionListener, "flyCamSpeedDown");
        inputManager.addListener(actionListener, "space");
        inputManager.addListener(actionListener, "manStyr");

        inputManager.addListener(actionListener, "skalhastOpp");
        inputManager.addListener(actionListener, "skalhastNed");
        inputManager.addListener(actionListener, "hoyningsknapp");

        inputManager.addListener(actionListener, "restartUpdate");
        inputManager.addListener(actionListener, "hopp");

        // numbers
        inputManager.addListener(actionListener, "0");
        inputManager.addListener(actionListener, "1");
        inputManager.addListener(actionListener, "2");
        inputManager.addListener(actionListener, "3");
        inputManager.addListener(actionListener, "4");
        inputManager.addListener(actionListener, "5");
        inputManager.addListener(actionListener, "6");
        inputManager.addListener(actionListener, "7");
        inputManager.addListener(actionListener, "8");
        inputManager.addListener(actionListener, "9");
        inputManager.addListener(actionListener, "x");
        inputManager.addListener(actionListener, "y");
        inputManager.addListener(actionListener, "z");

        //  Directional input
        inputManager.addListener(actionListener, "up");
        inputManager.addListener(actionListener, "left");
        inputManager.addListener(actionListener, "down");
        inputManager.addListener(actionListener, "right");

        // Mouse
        inputManager.addRawInputListener(rinInputListener);
    }

    private int noVrMouseXStart, noVrMouseYStart;
    private boolean noVrPersonMouseMovementActive = false;
    private boolean hoppActive = false;
    float lastMouseX = 0.0f;  //used for noVR camera movement
    float lastMouseY = 0.0f;  //used for noVR camera movement

    private RawInputListener rinInputListener = new RawInputListener() {
        public void beginInput() {
        }

        public void endInput() {
        }

        public void onJoyAxisEvent(JoyAxisEvent evt) {
        }

        public void onJoyButtonEvent(JoyButtonEvent evt) {
        }

        public void onMouseMotionEvent(MouseMotionEvent evt) {
            if (moveNiftyInfo1On) {
                moveNiftyInfo1(evt.getDX(), evt.getDY());
                return;
            }
            if (moveNiftyInfo2On) {
                moveNiftyInfo2(evt.getDX(), evt.getDY());
                return;
            }

            if (!TRACK_BUILD_MODE && !SCENARIO_BUILD_MODE && !mouseSpolOpened && !vrPerson.getNoVrPersonMode()) {
                return;
            }

            if (vrPerson.getNoVrPersonMode()) {
                float mouseX = evt.getX();
                float mouseY = evt.getY();
                //noVrPersonMoveForward = (evt.getY() - noVrMouseYStart) * 0.005f;
                vrPerson.setNoVrPersonRotateAlpha((mouseX - lastMouseX) * -1);
                vrPerson.setNoVrPersonRotateY((mouseY - lastMouseY) * -1);
                //noVrPersonRotateAlpha = evt.getDX() * 0.5f * -1f;
                lastMouseX = mouseX;
                lastMouseY = mouseY;
                vrPerson.setCamRotated(true);
                return;
            }

            if (!spolingOn) {
                return;
            }
            int midScr = StartParameters.worldPanelSizeY / 2;
            int speed = (evt.getY() - midScr) * 2;
            simVeh.setSpolingSpeedKmh(speed);
        }

        public void onMouseButtonEvent(MouseButtonEvent evt) {
            if (evt.getButtonIndex() == MouseInput.BUTTON_MIDDLE && evt.isPressed()) {
                if (!TRACK_BUILD_MODE && !SCENARIO_BUILD_MODE && !mouseSpolOpened && !vrPerson.getNoVrPersonMode()) {
                    return;
                }

                simVeh.setSpolingOn(true);
                spolingOn = true;

                // start spoling
                int midScr = StartParameters.worldPanelSizeY / 2;
                int speed = (evt.getY() - midScr) * 2;
                simVeh.setSpolingSpeedKmh(speed);
            }
            if (evt.getButtonIndex() == MouseInput.BUTTON_MIDDLE && evt.isReleased()) {
                simVeh.setSpolingOn(false);
                spolingOn = false;
            }

            // TrackBuilder
            if (TRACK_BUILD_MODE) {
                if ((evt.getButtonIndex() == MouseInput.BUTTON_LEFT || evt.getButtonIndex() == MouseInput.BUTTON_RIGHT)
                        && evt.isPressed()) {
                    trackBuildMouseInteraction(evt);
                }
            }

            // no vr person
            if (vrPerson.getNoVrPersonMode()) {
                if (evt.getButtonIndex() == MouseInput.BUTTON_RIGHT) {
                    vrPerson.noVrPersonModeTeleport(evt);
                        hoppActive = false;
                    
                    /*if (evt.isPressed()) {
                        noVrMouseXStart = evt.getX();
                        noVrMouseYStart = evt.getY();
                        noVrPersonMouseMovementActive = true;
                    } else {
                        if (evt.isReleased()) {
                            noVrPersonMouseMovementActive = false;
                            //noVrPersonMoveForward = 0;
                            vrPerson.setNoVrPersonRotateAlpha(0);
                        }
                    }*/
                } else {
                    if (evt.getButtonIndex() == MouseInput.BUTTON_LEFT && evt.isPressed()) {
                        vrPerson.noVrPersonModeMouseClick(evt);
                    }
                }

            }

        }

        public void onKeyEvent(KeyInputEvent evt) {
        }

        public void onTouchEvent(TouchEvent evt) {
        }
    };

    int kamPosIndex = 0;

    private ActionListener actionListener = new ActionListener() {
        public void onAction(String name, boolean isPressed, float tpf) {
            if (name.equals("up")) {
                if (!isPressed) {
                    upKey = 0;
                } else {
                    upKey = 1;
                }
            }
            if (name.equals("left")) {
                if (!isPressed) {
                    leftKey = 0;
                } else {
                    leftKey = 1;
                }
            }
            if (name.equals("down")) {
                if (!isPressed) {
                    downKey = 0;
                } else {
                    downKey = 1;
                }
            }
            if (name.equals("right")) {
                if (!isPressed) {
                    rightKey = 0;
                } else {
                    rightKey = 1;
                }
            }

            if (name.equals("trig") && isPressed) {
                testMoveTco();
            } else if (name.equals("spvtestpluss") && isPressed) {
                testSwitchPos(1);
            } else if (name.equals("spvtestminus") && isPressed) {
                testSwitchPos(-1);
            } else if (name.equals("toggleCam") && isPressed) {
                if (!vrOn) {
                    toggleCamNormal();
                } else {
                    vrPerson.toggleCamVR();
                }
            } else if (name.equals("flyCamSpeedUp") && isPressed) {
                flyCamSpeedIncrease();
            } else if (name.equals("flyCamSpeedDown") && isPressed) {
                flyCamSpeedDecrease();
            } else if (name.equals("space") && isPressed) {
                if (!StartParameters.balisesEditable) {
                    visPos();
                } else {
                    editBaliseCodeIndex++;
                    if (editBaliseCodeIndex == 3) {
                        editBaliseCodeIndex = 0;
                    }
                    editBaliseCodeNum = 0;
                }
            } else if (name.equals("manStyr") && isPressed) {
                loadManStyr();
            } else if (name.equals("skalhastOpp") && isPressed) {
                System.out.println("VR skalhast opp");
                int tskmh = ((SimSimpleVehicle) simVeh).getTractionFrame().getTargetSpeedKmH();
                tskmh += 5;
                if (tskmh > 250) {
                    tskmh = 250;
                }

                ((SimSimpleVehicle) simVeh).getTractionFrame().setTargetSpeedKmh(tskmh);
            } else if (name.equals("skalhastNed") && isPressed) {
                System.out.println("VR skalhast ned");
                int tskmh = ((SimSimpleVehicle) simVeh).getTractionFrame().getTargetSpeedKmH();
                tskmh -= 5;
                if (tskmh < 0) {
                    tskmh = 0;
                }

                ((SimSimpleVehicle) simVeh).getTractionFrame().setTargetSpeedKmh(tskmh);
            } else if (name.equals("hoyningsknapp") && isPressed) {
                System.out.println("hoyningsknapp trykt");
                ((SimSimpleVehicle) simVeh).getAtcPanel().vrHoyningPressed();
            } else if (name.equals("restartUpdate") && isPressed) {
                restartUpdate250();
            } else if (name.equals("0") && isPressed) {
                numberPressed(0);
            } else if (name.equals("1") && isPressed) {
                numberPressed(1);
            } else if (name.equals("2") && isPressed) {
                numberPressed(2);
            } else if (name.equals("3") && isPressed) {
                numberPressed(3);
            } else if (name.equals("4") && isPressed) {
                numberPressed(4);
            } else if (name.equals("5") && isPressed) {
                numberPressed(5);
            } else if (name.equals("6") && isPressed) {
                numberPressed(6);
            } else if (name.equals("7") && isPressed) {
                numberPressed(7);
            } else if (name.equals("8") && isPressed) {
                numberPressed(8);
            } else if (name.equals("9") && isPressed) {
                numberPressed(9);
            } else if (name.equals("x") && isPressed) {
                editBaliseCodeIndex = 0;
                editBaliseCodeNum = 0;
            } else if (name.equals("y") && isPressed) {
                editBaliseCodeIndex = 1;
                editBaliseCodeNum = 0;
            } else if (name.equals("z") && isPressed) {
                editBaliseCodeIndex = 2;
                editBaliseCodeNum = 0;
            } else if (name.equals("hopp") && isPressed) {
                hoppActive = true;
                System.out.println("hopp");
            }

        }
    };

    private void numberPressed(int i) {
        if (activeBalise == null) {
            return;
        }

        if (editBaliseCodeNum < 1) {
            editBaliseCodeNum = i;
        } else if (editBaliseCodeNum == 1) {
            editBaliseCodeNum = 10 + i;
        } else if (editBaliseCodeNum > 1) {
            editBaliseCodeNum = i;
        }

        if (editBaliseCodeIndex == 0) {
            activeBalise.setBaliseCodes(editBaliseCodeNum, activeBalise.getY(), activeBalise.getZ());
        } else if (editBaliseCodeIndex == 1) {
            activeBalise.setBaliseCodes(activeBalise.getX(), editBaliseCodeNum, activeBalise.getZ());
        } else if (editBaliseCodeIndex == 2) {
            activeBalise.setBaliseCodes(activeBalise.getX(), activeBalise.getY(), editBaliseCodeNum);
        }

        System.out.println("num pressed: " + i + " num: " + editBaliseCodeNum);
    }

    private void toggleCamNormal() {
        //vehicleCamActive = !vehicleCamActive;
        kamPosIndex++;
        if (kamPosIndex == 6) {
            kamPosIndex = 0;
        }

        guiNode.detachChild(crosshair); //dissables crosshair

        mouseInput.setCursorVisible(true);  //shows the mouse
        if (/*vehicleCamActive*/kamPosIndex == 0 || kamPosIndex == 1) {
            vrPerson.setNoVrPersonMode(false);
            vrPerson.setNoVrCamNodeLok(true);
            flyCam.setEnabled(false);
            vrPerson.setNoVrCamNodePerson(false);

            if (simVeh instanceof SimSimpleVehicle) {
                ((SimSimpleVehicle) simVeh).openDriverEnvironmentFrames();
            }

            //mouseInput.setCursorVisible(false);
            if (kamPosIndex == 1) {
                simVeh.changeToCamCab1();
            } else {
                simVeh.changeToCamCab2();
            }
        } else {
            if (kamPosIndex == 2 || kamPosIndex == 3) {
                // synlige vinduer
                if (simVeh instanceof SimSimpleVehicle) {
                    ((SimSimpleVehicle) simVeh).closeDriverEnvironmentFrames();
                }

                Vector3f camVec = new Vector3f(simVeh.getTrackRunner2().getPoint());
                camVec.y += 10;
                cam.setLocation(camVec);
                if (kamPosIndex == 2) {
                    cam.lookAtDirection(new Vector3f(0.0f, 0, 1), new Vector3f(0, 1, 0));
                } else {
                    cam.lookAtDirection(new Vector3f(0.0f, 0, -1), new Vector3f(0, 1, 0));
                }
                vrPerson.setNoVrCamNodePerson(false);
                vrPerson.setNoVrCamNodeLok(false);
                flyCam.setEnabled(true);

                //mouseInput.setCursorVisible(false);
            } else //kam index 4 el 5
            {
                // synlige vinduer
                if (simVeh instanceof SimSimpleVehicle) {
                    ((SimSimpleVehicle) simVeh).closeDriverEnvironmentFrames();
                }

                vrPerson.setNoVrPersonMode(true);
                Vector3f tr1vec = simVeh.getTrackRunner1().getPoint();

                // flytt person litt bort frå toget
                Node n1 = new Node();
                Node n2 = new Node();
                n2.setLocalTranslation(10, 0, 0);
                if (simVeh instanceof SimSimpleVehicle && ((SimSimpleVehicle) simVeh).getPersonOffsetVector() != null) {
                    n2.setLocalTranslation(((SimSimpleVehicle) simVeh).getPersonOffsetVector());
                }

                if (simVeh instanceof SimSimpleVehicle && ((SimSimpleVehicle) simVeh).getPersonRotationGrad() != 0) {
                    float angY = ((SimSimpleVehicle) simVeh).getPersonRotationGrad() * FastMath.DEG_TO_RAD;
                    //vrObserver.setLocalRotation(new Quaternion().fromAngleAxis(angY, new Vector3f(0, 1, 0)));
                }

                n1.attachChild(n2);
                n1.setLocalRotation(simVeh.getPivot().getWorldRotation());
                n1.setLocalTranslation(tr1vec);

                //person.setLocalTranslation(tr1vec.x+10, tr1vec.y, tr1vec.z+10);
                //person.setLocalTranslation(n2.getWorldTranslation());
                //rb.setPhysicsLocation(n2.getWorldTranslation());
                vrPerson.warp(n2.getWorldTranslation());

                //
                vrPerson.setNoVrCamNodeLok(false);
                flyCam.setEnabled(false);
                vrPerson.setNoVrCamNodePerson(true);
                mouseInput.setCursorVisible(false); //hides the cursor

                //enables crosshair
                guiNode.attachChild(crosshair);
            }
        }
    }

    private void flyCamSpeedIncrease() {
        if (flyCamSpeed > 400) {
            return;
        }

        flyCamSpeed += 10;

        flyCam.setMoveSpeed(flyCamSpeed);
    }

    private void flyCamSpeedDecrease() {
        if (flyCamSpeed <= 10) {
            return;
        }

        flyCamSpeed -= 10;

        flyCam.setMoveSpeed(flyCamSpeed);
    }

    private void loadManStyr() {
        System.out.println("Manuell styring");
        if (msf == null) {
            msf = new ManStyringFrame(this);
        } else {
            if (msf.isVisible()) {
                msf.setVisible(false);
            } else {
                msf.setVisible(true);
            }
        }
    }

    private void visPos() {
        float pos = simVeh.getTrackRunner2().getPosSection();
        System.out.println("SimVehicle pos in section: " + pos);

        if (tbFrame != null) {
            tbFrame.getTp().setPosInSection((int) pos + "");
        }

        findCloseByObjects();
    }

    private void findCloseByObjects() {
        TrackNode runner = null;
        if (simVeh.getDirection() == 1) {
            runner = simVeh.getTrackRunner2().neste;
        } else {
            runner = simVeh.getTrackRunner1().forrige;
        }

        while (runner != null && Math.abs(runner.getPos() - simVeh.getTrackRunner2().getPosSection()) < 200) {
            if (runner.getTrackSideObject() != null) {
                System.out.println("TCO: " + runner.getTrackSideObject().getClass() + " " + runner.getPos());
            }

            if (simVeh.getDirection() == 1) {
                runner = runner.neste;
            } else {
                runner = runner.forrige;
            }
        }
    }

    public static int sek10Counter;
    public static final int SEK10_MAX_COUNT = 5 * 10;

    private void updateFlashTick() // every 200 ms
    {
        // update all updateobjects
        for (UpdateObject u : updateObjectList) {
            u.update();
        }

        // testfunction
        if (!testfunctionSelfDriveOn) {
            return;
        }

        sek10Counter++;
        if (sek10Counter > SEK10_MAX_COUNT) {
            sek10Counter = 0;
            //loggController();
            testPurposeSelfDrive();
        }
    }

    public static boolean testfunctionSelfDriveOn = false;
    private Random random = new Random();
    private float shKmh = 0;

    private void testPurposeSelfDrive() {
        shKmh = random.nextInt(130) + 30;

        vrVehicle.getTractionFrame().setTargetSpeedKmh(shKmh);
        vrVehicle.getETCS().getActiveDMI().getDefaultPanelLeft().testBrakeRelease();
        if (!play) {
            togglePausePlay();
        }
    }

//  private void loggController()
//  {
//    Logg.enableAllLoggs();
//  }
    // int scenarioEventsCount = 0;
    private void updateTrainSystems() {
        vrVehicle.oppdaterETCS_extern();
    }

    public static void togglePausePlay() {
        if (play) {
            setPlay(false);
        } else {
            setPlay(true);
        }
    }

    public static void checkScenarioEvents() {
        for (ScenarioEvent se : scenarioEventList) {
            if (!se.isFinished()) {
                se.update();
            }
        }
    }

    public static int staticSecInterpreter(String name) {
        int k = 0;
        for (Section s : sectionList) {
            if (name.equals(s.getName())) {
                return k;
            }
            k++;
        }

        return 0;

    }

    public void posisjonerTogErtmsManuelt() {
        rbc.posisjonerTogManuelt(simVeh);
    }

    public void allowSH() {
        rbc.sendAllowModeSH(simVeh, true);
    }

    public void disAllowSH() {
        rbc.sendAllowModeSH(simVeh, false);
    }

//  private Vector3f personYRayLoc = new Vector3f();
//  private Vector3f personYRayDir = new Vector3f(0,-1,0);
    // TrackBuild Functions
    private void trackBuildMouseInteraction(MouseButtonEvent evt) {
        if ((evt.getButtonIndex() == MouseInput.BUTTON_LEFT || evt.getButtonIndex() == MouseInput.BUTTON_RIGHT)
                && evt.isPressed()) {
            System.out.println("mus: " + evt.getX() + " " + evt.getY());

            CollisionResults results = new CollisionResults();
            // Convert screen click to 3d position
            Vector2f click2d = inputManager.getCursorPosition();
            Vector3f click3d = cam.getWorldCoordinates(new Vector2f(click2d.x, click2d.y), 0).clone();
            Vector3f dir = cam.getWorldCoordinates(new Vector2f(click2d.x, click2d.y), 1f).subtractLocal(click3d).normalizeLocal();

            // Aim the ray from the clicked spot forwards.
            Ray ray = new Ray(click3d, dir);
            // Collect intersections between ray and all nodes in results list.

            rootNode.collideWith(ray, results);

            for (int i = 0; i < results.size(); i++) {
                float dist = results.getCollision(i).getDistance();
                Vector3f pt = results.getCollision(i).getContactPoint();
                String target = results.getCollision(i).getGeometry().getName();
                Geometry geom = results.getCollision(i).getGeometry();
                System.out.println("Selection #" + i + ": " + target + " at " + pt + ", " + dist + " WU away." + " orig: " + click3d + " dir: " + dir);
                if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_TCO_EDIT) {
                    dealWithPick(geom);
                } else {
                    if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_TCO_ADD) {
                        dealWithPickAddTco(pt, target, true); // true = active model
                    } else {
                        if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_TCO_PASSIV_ADD) {
                            dealWithPickAddTco(pt, target, false); // false = passive model
                        } else {
                            if (target.equals("Terrain")) {
                                if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_TEX) {
                                    //texturePick(pt, geom);
                                    terrainOperations.texturePick(pt, geom);
                                    System.out.println("texture pick:");
                                } else {
                                    if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_FORM) {
                                        //terrainPickMesh(pt, geom);
                                        terrainOperations.terrainPickMesh(pt, geom, evt.getButtonIndex());
                                        System.out.println("terrain pick:");
                                    } else {
                                        if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_OBJ_ADD) {
                                            //terrainPickMesh(pt, geom);
                                            terrainOperations.terrainAddObj(pt, geom, evt.getButtonIndex());
                                            System.out.println("terrain pick:");
                                        } else {
                                            if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_OBJ_EDIT
                                                    && tbFrame.getTp().getMarkedStod() != null) // UTFØR FLYTTING AV OBJEKT
                                            {
                                                tbFrame.getTp().getMarkedStod().setVec(pt);
                                                Vector3f vec = new Vector3f(pt);
                                                vec.y += tbFrame.getTp().getMarkedStod().getOffsetY();
                                                tbFrame.getTp().getMarkedStod().getSpatial().setLocalTranslation(vec);

                                                System.out.println("terrain pick - move teo:");
                                            }
                                        }
                                    }
                                }
                                break;
                            } else {
                                if (target.equals("AC3D_Terrain")) {
                                    if (tbFrame.getTp().getEditMode() == TbPanel.EDIT_MODE_OBJ_EDIT) {
                                        dealWithPickEditPassivObject(geom);
                                    }
                                    break;
                                }
                            }
                        }
                    }
                }
            }
        }
    }

    private boolean hasThisSpatial(Node no, Spatial sp) {
        for (Spatial s : no.getChildren()) {
            if (s instanceof Node) // Node
            {
                Node n = ((Node) s);
                if (!n.getChildren().isEmpty()) // vidare nedover
                {
                    boolean b1 = hasThisSpatial(n, sp);
                    if (b1) {
                        return true;
                    }
                }
            } else // Geometry
            {
                if (s == sp) {
                    return true;
                }
            }
        }

        return false;
    }

    private void dealWithPickEditPassivObject(Geometry geom) {
        ArrayList<StaticTerrainObjectData> objList = terrainOperations.getStatTerrObjDataList();

        for (StaticTerrainObjectData stod : objList) {
            boolean has = false;
            if (stod.getSpatial() instanceof Node) {
                has = hasThisSpatial((Node) stod.getSpatial(), geom);
            }

            if (has) {
                System.out.println("pointed at spatial found in obj: " + true + " " + stod.getAc3dFile());
                tbFrame.getTp().objToBeMarked(stod);
                return; //break;
            }
        }

    }

    private void dealWithPick(Geometry geom) {
        ArrayList<TrackConnectedObject> tcoList = sectionList.get(0).getTcoList();

        for (TrackConnectedObject tco : tcoList) {
            boolean has = hasThisSpatial(tco.getPivot(), geom);
            if (has) {
                System.out.println("pointed at spatial found in tco: " + has + " " + tco.getClass());
                tbFrame.getTp().tcoToBeMarked(tco);
                return; //break;
            }
        }

        // KL
        for (KL kl : tcoOperations.getKlList()) {
            boolean has = hasThisSpatial(kl.getPivot(), geom);
            if (has) {
                System.out.println("pointed at spatial found in tco: " + has + " " + kl.getClass());
                tbFrame.getTp().klToBeMarked(kl);
                return; //break;
            }
        }

    }

    private void dealWithPickAddTco(Vector3f pt, String target, boolean active) {
        Vector3f tpt = tcoOperations.findTrasePoint(pt);

        String objectName = tbFrame.getTp().getActiveTcoName();
        String fileName = ""; // BRUKES BARE TIL PASSIVE TCO

        if (!active) // VED PASSIVE TCO
        {
            objectName = "ALLPASSIVE";
            fileName = tbFrame.getTp().getActiveObjektFileName();
        }

        if (target.equals("Track")) // må klikke i sporet for add tco
        {
            tcoOperations.addTco(tpt, objectName, fileName, tbFrame.getTp().isAllVertices());
            tbFrame.getTp().tcoToBeMarked(tcoOperations.getLastAddedTco());
            tbFrame.getTp().setEditModeEditTco();
            forrigeTcoAdded = objectName;
        }
    }

    private boolean tbUpdatePosRelated = false;
    private TrackConnectedObject tcoWaitingToUpdatePosRelated;

    private boolean tbUpdateTcoDelete = false;
    private TrackConnectedObject tcoWaitingToBeDeleted;
    private StaticTerrainObjectData stodWaitingToBeDeleted;

    private boolean tbUpdateAttachToRootNode1 = false;
    private Node pivotWaitingToBeAttachedToRootNode1;

    private boolean tbUpdateAttachToRootNode2 = false;
    private Node pivotWaitingToBeAttachedToRootNode2;

    private boolean tbUpdateKlDelete = false;
    private KL klWaitingToBeDeleted;

    public void updateTCOPos(TrackConnectedObject tco) {
        tcoWaitingToUpdatePosRelated = tco;
        tbUpdatePosRelated = true;
    }

    public void setPivotWaitingToBeAttachedToRootNode1(Node pivotWaitingToBeAttachedToRootNode) {
        this.pivotWaitingToBeAttachedToRootNode1 = pivotWaitingToBeAttachedToRootNode;
        tbUpdateAttachToRootNode1 = true;
    }

    public void setPivotWaitingToBeAttachedToRootNode2(Node pivotWaitingToBeAttachedToRootNode) {
        this.pivotWaitingToBeAttachedToRootNode2 = pivotWaitingToBeAttachedToRootNode;
        tbUpdateAttachToRootNode2 = true;
    }

    private String forrigeTcoAdded = "KLMAST_KORT";

    public void addAutoKlKomponent(boolean alternateKLKomp) {
        float nyZ = tbFrame.getTp().getForrigeMarkedZ() + 50;
        String objektName = forrigeTcoAdded;
        int presetDir = tbFrame.getTp().getForrigeMarkedDir();
        float presetOffsetX = tbFrame.getTp().getForrigeMarkedOffsetX();

        tcoOperations.setPresetKlComponentOffsetX(finnPresetKlOffsetX(presetOffsetX));

        if (alternateKLKomp && forrigeTcoAdded.contains("KLMAST")) {
            if (forrigeTcoAdded.equals("KLMAST_KORT")) {
                objektName = "KLMAST_LANG";
                forrigeTcoAdded = "KLMAST_LANG";
            } else {
                objektName = "KLMAST_KORT";
                forrigeTcoAdded = "KLMAST_KORT";
            }
        }

        System.out.println("x: " + presetOffsetX);

        tcoOperations.setPresetKlComponentDirection(presetDir);
        tcoOperations.addTco(new Vector3f(0, 0, nyZ), objektName, "", false);
        tbFrame.getTp().setForrigeMarkedZ(nyZ);

        // reset x offset
        tcoOperations.setPresetKlComponentOffsetX(0);
    }

    public float finnPresetKlOffsetX(float forrigeOffsetX) {
        int i1 = (int) (forrigeOffsetX - 2.5f);

        if (forrigeOffsetX > 0) {
            i1 = (int) (forrigeOffsetX + 2.5f);
        }

        int i2 = i1 / 5;

        return i2 * 5;
    }

    public TrackConnectedObject findNextKlComp(TrackConnectedObject markedTco) {
        //System.out.println("Marked trackpoint: " + markedTco.getTrackPoint() + " " + markedTco.getOffsetVector());
        float startZ = markedTco.getTrackPoint().z;
        float startXOffset = markedTco.getOffsetVector().x;

        float closestZ = Float.MAX_VALUE;
        TrackConnectedObject closestTCO = null;

        for (TrackConnectedObject tco : sectionList.get(0).getTcoList()) {
            if (tco instanceof KLKomponent) {
                if (tco.getTrackPoint().z > (startZ + 5)
                        && tco.getTrackPoint().z < closestZ
                        && tco != markedTco
                        && (FastMath.abs(startXOffset - tco.getOffsetVector().x) < 0.5f)) {
                    closestZ = tco.getTrackPoint().z;
                    closestTCO = tco;
                }
            }
        }

        if (closestTCO != null) {
            System.out.println("Closest trackpoint: " + closestTCO.getTrackPoint() + " " + closestTCO.getOffsetVector());
        } else {
            System.out.println("Closest not found, returning null");
        }

        return closestTCO;
    }

    // tb
    public void tcoDetachAndRebuild(TrackConnectedObject tco) {
        tco.detachChildrenAndRebuild(assetManager);
    }

    public void tcoDelete() {
        tcoWaitingToBeDeleted = tbFrame.getTp().getMarkedTCO();
        tbUpdateTcoDelete = true;
    }

    public void objDelete() {
        stodWaitingToBeDeleted = tbFrame.getTp().getMarkedStod();
        tbUpdateTcoDelete = true;
    }

    // tb
    public void addKL(KLKomponent k1, KLKomponent k2) {
        tcoOperations.addKL(k1, k2);
    }

    public void klDelete() {
        klWaitingToBeDeleted = tbFrame.getTp().getMarkedKl();
        tbUpdateKlDelete = true;
    }

    public void setLineposAllErtmsSignal(float lineposOffset) {
        tcoOperations.setLineposAllErtmsSignal(lineposOffset);
    }

    public void saveAllTCOtoXML() {
        MyXmlSaverTCO.save(sectionList.get(0).getName(), sectionList.get(0).getTcoList());
        MyXmlSaverTCO.saveTRO(sectionList.get(0).getName(), sectionList.get(0).getTcoList(), tcoOperations.getKlList());
    }

    public void tb_flytt_tog(float offset) {
        System.out.println("flytt");
        float pos = simVeh.getOdometer();
        float nypos = pos + offset;

        simVeh.setOdometer(nypos);
    }

    public static ArrayList<Section> getSectionList() {
        return sectionList;
    }

    public static void StopApplication() {
        // real atc
        if (StartParameters.realatcseno) {
            System.out.println("Closing ATC USB communication");
            atcMetoder.closeHIDATCDevice();
        }

        if (StartParameters.storeFrameLocations) {
            StoreConfig.storeAllFrameLocations();
            //StoreConfig.storeAllGeneralConfig(); 26.09.2017
        }

        // vis poeng ved oppgavekjøring
        if (Program.showPointsDialogAtEnd) {
            JOptionPane.showMessageDialog(null, "Gjennom øvelsen har du samlet poeng på oppgavene\n\nDin totale poengsum ble: " + pointsTotal + " av " + pointsMax
                    + "\n\nTrykk OK for å avslutte", "Poengsum", JOptionPane.INFORMATION_MESSAGE);
        }

        // save logg
        Logg.saveLogg();
        System.exit(0);
    }

    private void cancelUpdate250() {
        updateTask250.cancel();
    }

    private void restartUpdate250() {
        System.out.println("cancel update 250 and restart");
        vrVehicle.getTractionFrame().setSkalHastPanelText("oppd 250 restart");

        cancelUpdate250();

        updateTask250 = new UpdateTask250();
        Timer newUpdateTimer250 = new Timer(true);
        newUpdateTimer250.schedule(updateTask250, 250, 250);
    }

    // Monitorering av 250 update etter problemer med at den skrur seg av
    private boolean update250Trigged = false;
    private boolean update250AlarmActivated = false;
    private int update250UnTriggedCount = 0;

    private void monitorUpdate250() {
        if (!update250Trigged) {
            update250UnTriggedCount++;
            if (!update250AlarmActivated && update250UnTriggedCount > 50) {
                vrVehicle.getTractionFrame().setSkalHastPanelText("oppd 250 feil");
                update250AlarmActivated = true;
            }
        } else {
            update250Trigged = false;
            update250UnTriggedCount = 0;
        }
    }

    // Private classes
    // oppdaterer feks blinking i signaler
    private class UpdateTask200 extends TimerTask {

        @Override
        public void run() {
            updateFlashTick();
            monitorUpdate250();
        }
    }

    // oppdaterer togsystemer - etcs, stm
    private class UpdateTask250 extends TimerTask {

        @Override
        public void run() {
            updateTrainSystems();
            update250Trigged = true;
        }
    }

}
